DECLARE SUB Delay (DelayTime!)
'*********************************************************************
'*   This is the main module for the entire SSPDATAQ controller program.
'*   The main event loop is housed here, as well as most of the data-
'*   processing funtions.  Port and file I/O is kept out of this module,
'*   as well as all directly pulldown-related data control.
'*
'*   To open and use these routines in the QuickBasic 4.5 development
'*   environment, you need to load the QuickLibrary EZQB.QLB included
'*   in the source directory of the distribution disk.  Use the following
'*   syntax to start QuickBasic:
'*
'*        QB /l [path]EZQB.QLB
'*
'*   In order to compile these routines the Quick Library EZQB.LIB must
'*   be present.
'*********************************************************************
'
DECLARE SUB SendInteg (Period!)
DECLARE SUB WriteCSF (TheTime$, Num%, Text$)
DECLARE FUNCTION FRead# ()
DECLARE FUNCTION IsFMode% ()
DECLARE FUNCTION IntegTime% ()
DECLARE SUB SetFileType ()
DECLARE SUB WriteFastHeader ()
DECLARE FUNCTION Fyle% ()
DECLARE FUNCTION SSPType% ()
DECLARE SUB DevShowMem ()
DECLARE SUB DevTemp ()
DECLARE SUB SelectFilter (Name$, FoundIt%)
DECLARE SUB SetCount2 (N AS LONG)
DECLARE FUNCTION BaseAddress% ()
DECLARE SUB SendFilter (Which%)
DECLARE SUB InitSSP ()
DECLARE FUNCTION LStr$ (Number AS INTEGER)
DECLARE SUB DrawBox (X1 AS INTEGER, Y1 AS INTEGER, X2 AS INTEGER, Y2 AS INTEGER, BackColor AS INTEGER)
DECLARE FUNCTION UnTopic$ (TheString$)
DECLARE SUB SetDLObject (Object$, Catalog$)
DECLARE SUB MenuFilter ()
DECLARE FUNCTION DumbDate$ ()
DECLARE FUNCTION UTimer# (Timervar#)
DECLARE FUNCTION IsSkyRead% ()
DECLARE SUB MenuSky (SkyType%)
DECLARE SUB SendFModeA ()
DECLARE SUB SendFModeB ()
DECLARE FUNCTION TruncTimer! ()
DECLARE SUB MenuTimedFast ()
DECLARE SUB MenuFInterval ()
DECLARE SUB SetFInterval (FInterval AS INTEGER)
DECLARE SUB MenuFInteg (N AS INTEGER)
DECLARE SUB SetFInteg (FInteg AS INTEGER)
DECLARE SUB ShowHelp ()
DECLARE SUB ContextHelp ()
DECLARE SUB SetFilterName (FiltName$)
DECLARE FUNCTION MakeCount$ (N AS LONG)
DECLARE SUB NotYetImp ()
DECLARE SUB WaitForKey (TheKey$)
DECLARE SUB ShowAbout ()
DECLARE SUB SetAutoObject ()
DECLARE SUB SetAutoSky ()
DECLARE SUB MenuReadTest ()
DECLARE FUNCTION IsValidCatalog% (Catalog$)
DECLARE SUB SetCatErr ()
DECLARE FUNCTION CatErr% ()
DECLARE FUNCTION IsTestRead% ()
DECLARE SUB SetSky (SkyType%)
DECLARE SUB SetCatalog (Catalog$)
DECLARE SUB QBMouse (A!, b!, c!, D!)
DECLARE SUB CloseOList ()
DECLARE SUB RestoreScreen ()
DECLARE SUB DoShell ()
DECLARE SUB WriteCfg ()
DECLARE SUB WriteCS (Text$)
DECLARE SUB SetGain (N!)
DECLARE SUB SetInteg (N%)
DECLARE SUB SetInterval (N!)
DECLARE SUB SetTimeOptions ()
DECLARE SUB Message (Text$)
COMMON SHARED NiteMode$, UTDif%, UTOrLoc$, CommOpen%, DefaultPort$, DefaultBaud$, SixOrTen%, AorM$
DECLARE SUB MenuGain ()
DECLARE SUB DoHalt ()
DECLARE SUB AskForComments ()
DECLARE SUB WriteCharsHL (Win AS INTEGER, ToWrite$)
DECLARE FUNCTION OListDone$ ()
DECLARE SUB PromptLObject (Object$, Catalog$)
DECLARE SUB DoOList ()
DECLARE SUB OpenOList ()
DECLARE SUB GetNextObject (Object$, Cat$, Filt$)
DECLARE FUNCTION FindFilter1% (FilterName$)
DECLARE SUB PromptWithDefault (Prompt$, Default$, Result$)
DECLARE SUB WriteSlowHeader (TeleName$, Obsv$, Comment$)
DECLARE FUNCTION NewFileQuery% ()
DECLARE SUB SetDataLine (Object$, Catalog$)
DECLARE SUB WriteSlowLine (DL AS ANY)
DECLARE SUB CheckInterval (Force AS INTEGER)
DECLARE SUB MenuRead ()
DECLARE SUB MenuObject (Object$)
DECLARE SUB MenuCatalog (Catalog$)
DECLARE SUB WriteFastMode (ToWrite AS ANY)
DECLARE SUB StartOList ()
DECLARE FUNCTION OutPutMode! ()
DECLARE SUB HomeFilter (Which AS INTEGER)
DECLARE SUB MenuInterval ()
DECLARE SUB MenuInteg ()
DECLARE SUB SendRead ()
DECLARE SUB OpenFile ()
DECLARE SUB CloseFile ()
DECLARE FUNCTION GetTime$ ()
DECLARE SUB Prompt (PromptLine$, Result$)
DECLARE SUB DrawStatusWin2 ()
DECLARE SUB PromptKey (TheKey$)
DECLARE SUB EatKey (AnyKey$)
DECLARE SUB DoEvents ()
DECLARE SUB HomeFilters ()
DECLARE SUB SetTime ()
DECLARE SUB SetObject (Object$)
DECLARE SUB DrawStatusWin3 ()
DECLARE SUB ToggleNite ()
REM $DYNAMIC

TYPE S1                            ' The first status window
     Object    AS STRING * 10
     Catalog   AS STRING * 1
     Filter    AS INTEGER
     FiltName  AS STRING * 12
     Integ     AS INTEGER
     Gain      AS INTEGER
     SkyType   AS INTEGER
     AutoSky   AS INTEGER
     AutoObject AS INTEGER
     Interval  AS INTEGER
     WheelA    AS INTEGER
END TYPE

TYPE S3
     LTime     AS STRING * 10
     UTime     AS STRING * 10
     UDate     AS STRING * 10
     LDate     AS STRING * 10
END TYPE

TYPE CS
     DTime     AS SINGLE
     DDate     AS SINGLE
     IDate     AS STRING * 10
     ITime     AS STRING * 12
     DCount    AS SINGLE
END TYPE


TYPE FastCount
     Num       AS INTEGER
     ITime     AS STRING * 12
     Counts    AS INTEGER
END TYPE

TYPE DataLine
     IDate     AS STRING * 10
     ITime     AS STRING * 8
     Catalog   AS STRING * 1
     Object    AS STRING * 10
     Filter    AS STRING * 2
     CurInteg  AS INTEGER
     C1        AS LONG
     C2        AS LONG
     C3        AS LONG
     C4        AS LONG
     Integ     AS INTEGER
     Gain      AS INTEGER
     Comments  AS STRING * 20
END TYPE

TYPE InData          'Internally referenced data
     ActiveWheel    AS INTEGER
     ActiveFilter   AS INTEGER
     FInterval      AS INTEGER
     FNum           AS INTEGER
     FMEndTime      AS SINGLE
END TYPE

DIM SHARED WasError%
DECLARE SUB AbortErr (Error$)
DECLARE FUNCTION IsOListRead% ()
DECLARE SUB MenuFRead (N%)
DECLARE FUNCTION IsValidHexChar% (Char$)
DECLARE SUB MenuFreeFast ()
DECLARE FUNCTION TimerToTime$ (NumSecs AS DOUBLE)
DECLARE FUNCTION HexToDec& (N$)
DECLARE SUB DispatchMenu (Menu%, Item%)
DECLARE FUNCTION NumPos% ()
DECLARE SUB DoPullDown (Menu%, Item%)
DECLARE SUB InitPullDown ()
DECLARE SUB SetFiltPos (F1%)
DECLARE SUB DrawStatusWin1 ()
DECLARE SUB LocRel (Win AS INTEGER, Rx AS INTEGER, Ry AS INTEGER)
DECLARE SUB InitWindows ()
DECLARE SUB WriteChars (Win AS INTEGER, ToWrite$)
DECLARE SUB NewLine (Win AS INTEGER)
DECLARE SUB BackSpace (Win AS INTEGER)
DECLARE SUB Init ()
DECLARE SUB KeyPressed (KeyIn$)
DECLARE SUB EventLoop ()
DECLARE SUB Quit ()
DECLARE FUNCTION NewWindow (X1 AS INTEGER, Y1 AS INTEGER, X2 AS INTEGER, Y2 AS INTEGER, BackColor AS INTEGER, ForeColor AS INTEGER, Title$)
DECLARE FUNCTION KeyReady ()
DECLARE FUNCTION GetKey$ ()
DECLARE FUNCTION AltPressed% ()
DECLARE FUNCTION MouseInMenu% ()
DECLARE FUNCTION Filter$ (Number%)

COMMON SHARED TermMode AS INTEGER
COMMON SHARED Internal AS InData
DIM SHARED NoDataComp%
DIM SHARED DataCompPrompted%, HardWare%
DIM SHARED TermWin AS INTEGER, StatusWin1 AS INTEGER, StatusWin2 AS INTEGER, StatusWin3 AS INTEGER, Running AS INTEGER, PromptWin AS INTEGER, CountStatusWin AS INTEGER, AboutWin AS INTEGER, HelpWin AS INTEGER, TopicWin AS INTEGER
DIM SHARED Status1 AS S1, Status3 AS S3, CountStatus AS CS, Idle AS INTEGER, IdleMode AS INTEGER
DIM SHARED PromptResult$, Interval AS INTEGER, IntervalPlace AS INTEGER, AbortRead%, BaseAd%
DIM SHARED FastModeOut(0) AS FastCount, MaxFastCounts AS INTEGER, CurFastCount AS INTEGER
DIM SHARED CurDL AS DataLine
DIM SHARED CSLines$(11)
DIM SHARED TestRead%, OListRead%, SkyRead%, NotAStart%, IsFastMode%, OLDone%, OLHalt%

DIM SHARED CommentLine$(8, 100), FModeData&(0)

DIM SHARED CatErrCheck AS INTEGER
DIM SHARED FiltNames$(16)
ON ERROR GOTO CouldNotOpenFilter
     OPEN "FILTERS.CFG" FOR INPUT AS #1
ON ERROR GOTO 0
cntr = 1
DO UNTIL EOF(1)
     LINE INPUT #1, Temp0$
     IF LEFT$(Temp0$, 1) <> "*" THEN
          FiltNames$(cntr) = LEFT$(Temp0$, INSTR(Temp0$, ",") - 1)
          cntr = cntr + 1
     END IF
LOOP

DIM SHARED MonthData(12)     'This is the reference array for time data
     MonthData(1) = 31
     MonthData(2) = 28
     IF VAL(RIGHT$(DATE$, 4)) MOD 4 = 0 THEN
          IF VAL(RIGHT$(DATE$, 4)) MOD 400 <> 0 THEN MonthData(2) = 29
     END IF
     MonthData(3) = 31
     MonthData(4) = 30
     MonthData(5) = 31
     MonthData(6) = 30
     MonthData(7) = 31
     MonthData(8) = 31
     MonthData(9) = 30
     MonthData(10) = 31
     MonthData(11) = 30
     MonthData(12) = 31



Col% = 8
CALL Init

CALL EventLoop
COLOR 7, 0
CLS


Ender:
END

CouldNotOpenComm:
     Message ("Could not open default comm port!")
     RESUME NEXT

OListHalted:   'Called on an F10 while running an OList
     OLHalt% = 1
     RETURN

Rezoom:
     CALL EventLoop

CouldNotOpenCfg:
     CLS
     PRINT "Fatal error: The file DPARMS.CFG is not in the current directory."
     PRINT "If you cannot find your DPARMS.CFG file, see section II.1 of the SSP"
     PRINT "control software manual for the format of the file.  From that you"
     PRINT "can use any standard text editor to write a new file."
     RESUME Ender

CouldNotOpenFilter:
     CLS
     PRINT "Fatal error: The file FILTERS.CFG is not in the current directory."
     PRINT "If you cannot find your FILTERS.CFG file, see section II.2 of the"
     PRINT "control software manual for the format of the file.  From that you"
     PRINT "can use any standard text editor to write a new file."
     PRINT
     PRINT "You can also find a default FILTERS.CFG file on the install disk"
     PRINT "for your control software.  The file may be copied directly from"
     PRINT "the disk."
     RESUME Ender

NoFileAccess:
     COLOR 7, 0
     CLS
     PRINT "For some reason, this terminal is not allowed to access certain"
     PRINT "files in the current directory.  This is interfering with SSPDATAQ.EXE's"
     PRINT "file access and should be remedied before running SSPDATAQ.EXE again."
     PRINT "You might try checking your network settings."
     RESUME Ender

HelpTime:                'This is called when the user presses F1
     CALL ContextHelp
     RETURN

FileError:
     COLOR 7, 0
     CLS
     PRINT "SSPDATAQ.EXE was unable to find the help file SSPDATAQ.HLP.  If you"
     PRINT "cannot find this file, there is a copy on the SSPDATAQ distribution"
     PRINT "disk."
     RESUME Ender

'

REM $STATIC
'*********************************************************************
'*   This sub aborts the proram safely, giving the user a clue as to
'*   what went wrong.
'*
'*********************************************************************
'
SUB AbortErr (Error$)

     SCREEN 0, 0, 0, 0
     COLOR 7, 0
     CLS

     PRINT "Fatal error in execution:"
     PRINT Error$
     PRINT
     PRINT

     WasError% = 1
     CLOSE

     END

END SUB '

 '*********************************************************************
'*   This routine asks for comments about the observation just
'*   taken and fills in the Comments field of the global CurDL
'*   variable
'*
'*********************************************************************
'
SUB AskForComments

     CALL Prompt("Enter comments for observation: ", temp$)

     CurDL.Comments = LEFT$(temp$, 20)

END SUB '

FUNCTION BaseAddress%

     BaseAddress% = BaseAd%

END FUNCTION

'*********************************************************************
'*  This is the wrapper function for the CatErrCheck variable.  This
'*  function returns a 1 if Catalog Error Checking is enabled.
'*
'*
'*********************************************************************
'
FUNCTION CatErr%

     CatErr% = CatErrCheck

END FUNCTION

'*********************************************************************
'*   This routine will check to see if an interval has been set,
'*   and if it is in the range for the OType (1 = 1-4, 2 = 1-400).
'*   If the interval is not appropiate or Force is set, an interval
'*   will be prompted for.
'*********************************************************************
'
SUB CheckInterval (Force AS INTEGER)

STATIC LastSInterval$
    
IF (Interval < 1) OR (Force = 1) THEN
     DO
          CALL PromptWithDefault("Enter new interval (1-4): ", LastSInterval$, temp$)
     LOOP UNTIL VAL(temp$) > 0 AND VAL(temp$) < 5
     LastSInterval$ = temp$
     CALL SetInterval(VAL(temp$))
END IF

END SUB '

'*************************************************************************
'*   This sub sets the Data Compression Prompted flag to off
'*
'*
'*************************************************************************
'
SUB ClearDataCompPrompted
    
     DataCompPrompted% = 0

END SUB

'*********************************************************************
'*   This is the sub called when the user presses the F1 key.  Right
'*   now, it just calls the ShowHelp routine.
'*
'*********************************************************************
'
SUB ContextHelp

     KEY(1) OFF
     CALL ShowHelp
     KEY(1) ON

END SUB

SUB DevShowMem

COLOR 0, 7
CLS
SHELL "mem"
CALL WaitForKey(temp$)
CALL RestoreScreen

END SUB

SUB DevTemp

END SUB

SUB DispatchMenu (Menu%, Item%)

SELECT CASE Menu%
     CASE 1    'File Menu
          SELECT CASE Item%
               CASE 1
                    CALL OpenFile
               CASE 2
                    CALL CloseFile
               CASE 3
                    CALL OpenOList
               CASE 5
                    CALL Quit
          END SELECT
     CASE 2    'Object Menu
          SELECT CASE Item%
               CASE 1
                    CALL MenuObject(Object$)
               CASE 2
                    CALL MenuCatalog(Catalog$)
               CASE 3
                    CALL MenuFilter
               CASE 5
                    CALL MenuSky(2)
               CASE 6
                    CALL MenuSky(1)
               CASE 7
                    CALL MenuSky(3)
          END SELECT
     CASE 3    'Run Menu
          SELECT CASE Item%
               CASE 1
                    CALL MenuReadTest
               CASE 3
                    ON KEY(10) GOSUB OListHalted
                    KEY(10) ON
                    OListRead% = 1
                    CALL StartOList
                    IF OutPutMode = 2 THEN CALL MenuRead
                    OListRead% = 0
                    KEY(10) ON
               CASE 4
                    CALL MenuRead
               CASE 5
                    CALL MenuFRead(0)
               CASE 6
                    CALL MenuFRead(1)
               CASE 7
                    CALL MenuFRead(2)
               CASE 8
                    CALL SetAutoObject
               CASE 9
                    CALL SetAutoSky
          END SELECT
     CASE 4    'Parms Menu
          SELECT CASE Item%
               CASE 1
                    CALL HomeFilters
               CASE 2
                    CALL MenuInterval
               CASE 3
                    CALL MenuFInterval
               CASE 4
                    CALL MenuInteg
               CASE 5
                    CALL MenuGain
          END SELECT
     CASE 5    'Filter Menu
          IF Item% > 0 THEN CALL SendFilter(Item%)
     CASE 6    'Setup Menu
          SELECT CASE Item%
               CASE 1
                    CALL ToggleNite
               CASE 2
                    CALL SetCatErr
               CASE 3
                    CALL SetTimeOptions
          END SELECT
     'CASE 7
     '     SELECT CASE Item%
     '          CASE 1
     '               CALL DevShowMem
     '          CASE 2
     '               CALL DevTemp
     '     END SELECT
     CASE 7
          SELECT CASE Item%
               CASE 1
                    CALL ShowHelp
               CASE 2
                    CALL ShowAbout
          END SELECT
END SELECT

END SUB

SUB DoEvents

IF AltPressed% OR MouseInMenu% THEN
     CALL DoPullDown(Menu%, Item%)
     CALL DispatchMenu(Menu%, Item%)
END IF

CALL SetTime

END SUB

'*********************************************************************
'*   This is called when the user selects the halt option from the menu.
'*   All it does is call the FILEOUT routine to close the current OList.
'*
'*********************************************************************
'
SUB DoHalt

     'CALL CloseOList

END SUB '

'*********************************************************************
'*   This is the routine called when an OList interval is completed.
'*   It reads the next object in from the OList and selects the correct
'*   filter for the next interval.  The user is then given a prompt with
'*   default for the next interval length.
'*********************************************************************
'
SUB DoOList
             
STATIC LastObject$

     IsBadFilt% = 0
     DoPause% = 1
     IF Status1.AutoSky = 1 THEN
          IF Status1.AutoObject = 1 THEN DoPause% = 0
          IF LEFT$(Status1.Object, 3) = "SKY" THEN DoPause% = 0
     END IF

     IF DoPause% THEN
          CALL Message("Press any key to continue...")
          CALL WaitForKey(temp$)
          CALL Message(" ")
     END IF
    
NotYet:
     IF EOF(3) THEN
          OLDone% = 1
          EXIT SUB
     END IF
     CALL GetNextObject(Object$, Catalog$, NextFilter$)
     CALL SetObject(Object$)
     CALL SelectFilter(NextFilter$, FoundIt%)
     IF FoundIt% <> 1 THEN GOTO NotYet:
         
     IF LastObject$ <> Object$ THEN
          IF NotAStart% = 1 THEN CALL AskForComments
          CALL PromptLObject(Object$, Catalog$)
          LastObject$ = Object$
          CALL CheckInterval(1)
          CALL Message("Running OList.  Press <F10> to halt.")
     END IF
   
     IF NotAStart% = 1 THEN
          CALL WriteSlowLine(CurDL)
          CALL SetDataLine(Object$, Catalog$)
          NotAStart% = 0
     END IF

     CALL SetDLObject(Object$, Catalog$)

END SUB '

'************************************************************************
'*   This routine was originally added in to the FILE menu to provide the
'*   user with a way to run DOS commands without losing all his parameters.
'*   I ran into major problems with trying to use it while the SSP
'*   was idling, however, so it has not yet been implemented.
'************************************************************************
'
SUB DoShell
    
     COLOR 7, 0
     IF NiteMode$ = "Y" THEN COLOR 4, 0
     CLS
     SHELL
    
     CALL RestoreScreen
     'Message ("Returned from DOS shell.")

END SUB

'*********************************************************************
'*   This sets up the Optical Status window - i.e. draws in the labels
'*   in the correct positions.  If the status layout is rearanged, then
'*   this is what needs to be changed.  Positions are relative to the
'*   window, with (1,1) being the upper left hand corner
'*********************************************************************
'
SUB DrawStatusWin1

     CALL LocRel(StatusWin1, 4, 1)
     CALL WriteChars(StatusWin1, "Interval:")
     CALL LocRel(StatusWin1, 31, 1)
     CALL WriteChars(StatusWin1, "Object:")
     CALL LocRel(StatusWin1, 1, 2)
     CALL WriteChars(StatusWin1, "Integration:")
     CALL LocRel(StatusWin1, 30, 2)
     CALL WriteChars(StatusWin1, "Catalog:")
     IF AorM$ = "Y" THEN
         CALL LocRel(StatusWin1, 2, 3)
         CALL WriteChars(StatusWin1, "Auto Scale:")
     ELSE
         CALL LocRel(StatusWin1, 7, 3)
         CALL WriteChars(StatusWin1, "Scale:")
     END IF
     CALL LocRel(StatusWin1, 31, 3)
     CALL WriteChars(StatusWin1, "Filter:")
     CALL LocRel(StatusWin1, 2, 4)
     CALL WriteChars(StatusWin1, "AutoObject:")
     CALL LocRel(StatusWin1, 29, 4)
     CALL WriteChars(StatusWin1, "Sky Type:")
     CALL LocRel(StatusWin1, 5, 5)
     CALL WriteChars(StatusWin1, "AutoSky:")
     CALL LocRel(StatusWin1, 28, 5)
     CALL WriteChars(StatusWin1, "File Type:")

END SUB

'*************************************************************************
'*   This draws the third status window; the "time" window.
'*
'*
'*
'*************************************************************************
'
SUB DrawStatusWin3
    CALL LocRel(StatusWin3, 2, 1)
    CALL WriteChars(StatusWin3, "UT Time:")
    CALL LocRel(StatusWin3, 2, 2)
    CALL WriteChars(StatusWin3, "UT Date:")
    CALL LocRel(StatusWin3, 2, 4)
    CALL WriteChars(StatusWin3, "  Local:")
    CALL LocRel(StatusWin3, 2, 5)
    CALL WriteChars(StatusWin3, "   Date:")
END SUB

'********************************************************************
'*   This function returns the current date in the dumb form that
'*   RPHOT expects:  i.e. "SEP 21 1989".  Sheesh.
'*
'********************************************************************
'
FUNCTION DumbDate$

     Month$ = MID$(DATE$, 1, 2)
     Day$ = MID$(DATE$, 4, 2)
     Year$ = MID$(DATE$, 7, 4)

     SELECT CASE Month$
          CASE "01"
               DumbMonth$ = "JAN"
          CASE "02"
               DumbMonth$ = "FEB"
          CASE "03"
               DumbMonth$ = "MAR"
          CASE "04"
               DumbMonth$ = "APR"
          CASE "05"
               DumbMonth$ = "MAY"
          CASE "06"
               DumbMonth$ = "JUN"
          CASE "07"
               DumbMonth$ = "JUL"
          CASE "08"
               DumbMonth$ = "AUG"
          CASE "09"
               DumbMonth$ = "SEP"
          CASE "10"
               DumbMonth$ = "OCT"
          CASE "11"
               DumbMonth$ = "NOV"
          CASE "12"
               DumbMonth$ = "DEC"
     END SELECT
    
     'This cuts the leading zeros off the day
     DumbDay$ = RIGHT$(STR$(VAL(Day$)), 2)
    
     DumbDate$ = DumbMonth$ + " " + DumbDay$ + " " + Year$

END FUNCTION

'*********************************************************************
'*   This is the default key handler for mode 3 - nothing happens to
'*   the key - it just disappears.  If any special hot keys are desired
'*   consider putting them here.
'*
'*********************************************************************
'
SUB EatKey (AnyKey$)

END SUB '

'*********************************************************************
'*   This is the main call to DoEvents, that keeps repeating until
'*   running is set to false.
'*
'*
'*********************************************************************
'
SUB EventLoop
  
     ON KEY(1) GOSUB HelpTime
     KEY(1) ON

     DO
          CALL DoEvents
     LOOP WHILE Running%

     KEY(1) OFF

END SUB '

'*********************************************************************
'*   This function converts the floating point number of seconds since
'*   midnight into a string of the form hh:mm:ss:ttt
'*
'*
'*********************************************************************
'
FUNCTION GetTime$

     DIM Time AS SINGLE, Result$, Hours AS INTEGER, Minutes AS INTEGER, Seconds AS INTEGER
     DIM Thousands AS INTEGER

     Time = TIMER

     Hours = INT(Time / 3600)
     Time = Time - (Hours * 3600!)

     Minutes = INT(Time / 60)
     Time = Time - (Minutes * 60)

     Seconds = INT(Time)
     Time = Time - Seconds

     Thousands = INT(Time * 1000)

     GetTime$ = RIGHT$("0" + LStr$(Hours), 2) + ":" + RIGHT$("0" + LStr$(Minutes), 2) + ":" + RIGHT$("0" + LStr$(Seconds), 2) + "." + RIGHT$("00" + LStr$(Thousands), 3)

END FUNCTION '

'*********************************************************************
'*   This is the main init routine for the entire program.  The Pulldowns
'*   and windows are all initialized and drawn here, along with setting
'*   a few modes and flags, some of which are read from the DPARMS.CFG and
'*   FILTERS.CFG files.  It also saves all the comment lines in DPARMS.CFG
'*   in an array so that they don't get lost when the config file is
'*   rewritten.
'*********************************************************************
'
SUB Init
                    
     COLOR 7, 0
     CLS

     IF Running = 0 THEN
          'Open and read the config file

          ON ERROR GOTO CouldNotOpenCfg
               OPEN "dparms.cfg" FOR INPUT AS #5
          ON ERROR GOTO 0
          NiteMode$ = "X"
          cntr = 1
          DO UNTIL NiteMode$ <> "X"
               LINE INPUT #5, temp$
               IF LEFT$(temp$, 1) <> "*" THEN
                    IF UCASE$(LEFT$(temp$, 1)) = "N" THEN
                         NiteMode$ = "Y"
                    ELSE
                         NiteMode$ = "N"
                    END IF

               ELSE
                    CommentLine$(1, cntr) = temp$
                    cntr = cntr + 1
               END IF
          LOOP
         
          UTDif% = 42
          cntr = 1
          DO UNTIL UTDif% <> 42
               LINE INPUT #5, temp$
               IF LEFT$(temp$, 1) <> "*" THEN
                    UTDif% = VAL(temp$)
               ELSE
                    CommentLine$(2, cntr) = temp$
                    cntr = cntr + 1
               END IF
          LOOP

          UTOrLoc$ = "XXXX"
          cntr = 1
          DO UNTIL UTOrLoc$ <> "XXXX"
               LINE INPUT #5, temp$
               IF LEFT$(temp$, 1) <> "*" THEN
                    UTOrLoc$ = UCASE$(temp$)
               ELSE
                    CommentLine$(3, cntr) = temp$
                    cntr = cntr + 1
               END IF
                                
          LOOP
                  
          BaseAd% = 42
          cntr = 1
          DO UNTIL BaseAd% <> 42
               LINE INPUT #5, temp$
               IF LEFT$(temp$, 1) <> "*" THEN
                    BaseAd% = VAL(temp$)
               ELSE
                    CommentLine$(4, cntr) = temp$
                    cntr = cntr + 1
               END IF
          LOOP
         
          HardWare% = 42
          cntr = 1
          DO UNTIL HardWare% <> 42
               LINE INPUT #5, temp$
               IF LEFT$(temp$, 1) <> "*" THEN
                    HardWare% = VAL(temp$)
               ELSE
                    CommentLine$(5, cntr) = temp$
                    cntr = cntr + 1
               END IF
          LOOP
        
          IF HardWare% > 4 OR HardWare% < 1 THEN
               CALL AbortErr("Error in DPARMS.CFG:  Invalid Hardware type: " + STR$(HardWare%))
          END IF
         
          SixOrTen% = 42
          cntr = 1
          DO UNTIL SixOrTen% <> 42
               LINE INPUT #5, temp$
               IF LEFT$(temp$, 1) <> "*" THEN
                    SixOrTen% = VAL(temp$)
               ELSE
                    CommentLine$(6, cntr) = temp$
                    cntr = cntr + 1
               END IF
          LOOP
         
          AorM$ = "X"
          cntr = 1
          DO UNTIL AorM$ <> "X"
               LINE INPUT #5, temp$
               IF LEFT$(temp$, 1) <> "*" THEN
                    IF UCASE$(LEFT$(temp$, 1)) = "A" THEN
                        AorM$ = "Y"
                    ELSE
                        AorM$ = "N"
                    END IF
               ELSE
                    CommentLine$(7, cntr) = temp$
                    cntr = cntr + 1
               END IF
          LOOP

          cntr = 1
          DO UNTIL EOF(5)
               LINE INPUT #5, CommentLine$(8, cntr)
               cntr = cntr + 1
          LOOP
          CLOSE #5

     END IF

     CALL InitWindows
     CALL InitPullDown
    
     IF NiteMode$ = "Y" THEN FC% = 4 ELSE FC% = 7
     IF NiteMode$ = "Y" THEN BC% = 0 ELSE BC% = 1
     StatusWin1 = NewWindow(1, 19, 55, 25, BC%, FC%, "Instrument Status")
     StatusWin3 = NewWindow(56, 19, 80, 25, BC%, FC%, "Time")
     PromptWin = NewWindow(1, 16, 80, 18, BC%, FC%, "Message")
     CountStatusWin = NewWindow(1, 2, 80, 15, BC%, FC%, "Count Status")

     CALL DrawStatusWin1
     CALL DrawStatusWin3
     SetTime
     TermMode = 3
    
     CALL SetFilterName(Filter$(1))
     CALL SetObject("Default")
     CALL SetCatalog("A")
     CALL SetSky(1)
     CALL SetCatErr
     CALL SetAutoSky
     CALL SetAutoObject
     CALL SetInteg(1000)
     CALL SetInterval(1)
     CALL SetFileType
     CALL SetFInterval(10)
     CALL InitSSP                     'Call subroutine to initialize SSPCARD

     Running = 1

     CALL QBMouse(1, 0, 0, 0)           'show mouse cursor
     CALL QBMouse(10, 0, &H7000, 3844)  'set mouse cursor
     CALL MenuGain

END SUB

FUNCTION IntegTime%

     IntegTime% = Status1.Integ

END FUNCTION

FUNCTION IsFMode%

     IsFMode% = IsFastMode%

END FUNCTION

'*********************************************************************
'*   This is the wrapper function for the OListRead% variable.  It
'*   returns a true if we are currently in an OList reading.
'*
'*********************************************************************
'
FUNCTION IsOListRead%

     IsOListRead% = OListRead%

END FUNCTION

'*********************************************************************
'*   This function returns a 1 if the current read is a sky reading.
'*
'*
'*********************************************************************
'
FUNCTION IsSkyRead%

     IsSkyRead% = SkyRead%

END FUNCTION

'*********************************************************************
'*   This is the wrapper function for the TestRead% flag set when
'*   Read Trial is occurring.
'*
'*
'*********************************************************************
'
FUNCTION IsTestRead%

     IsTestRead% = TestRead%

END FUNCTION

'*********************************************************************
'*   This function returns a 1 if the specified string is a valid
'*   catalog name.  If any new catalog names are needed, this is the
'*   place to put them.
'*
'*********************************************************************
'
FUNCTION IsValidCatalog% (Catalog$)

     IsValidCatalog% = 0
     IF Catalog$ = "A" THEN IsValidCatalog% = 1
     IF Catalog$ = "F" THEN IsValidCatalog% = 1
     IF Catalog$ = "S" THEN IsValidCatalog% = 1
     IF Catalog$ = "C" THEN IsValidCatalog% = 1
     IF Catalog$ = "V" THEN IsValidCatalog% = 1
     IF Catalog$ = "M" THEN IsValidCatalog% = 1
     IF Catalog$ = " " THEN IsValidCatalog% = 1

END FUNCTION

'*********************************************************************
'*   This function returns a 1 if the specified character is a valid
'*   hex character: 0123456789ABCDEF
'*
'*********************************************************************
'
FUNCTION IsValidHexChar% (Char$)

     IsValidHexChar% = 0
     IF 47 < ASC(Char$) AND ASC(Char$) < 58 THEN IsValidHexChar% = 1
     IF 64 < ASC(Char$) AND ASC(Char$) < 71 THEN IsValidHexChar% = 1

END FUNCTION

'*********************************************************************
'*   This routine takes a keystroke and passes it to the appropiate
'*   keyboard handling routine.  If a globally active hot key is needed,
'*   put the code here.
'*
'*********************************************************************
'
SUB KeyPressed (KeyIn$)

     IF KeyIn$ = CHR$(27) THEN AbortRead% = 1
    
     CALL EatKey(KeyIn$)

END SUB '

'*********************************************************************
'*   This is a slightly modified version of the STR$ function that
'*   takes the leading space off of positive numbers.
'*
'*
'*********************************************************************
'
FUNCTION LStr$ (Number AS INTEGER)

     temp$ = STR$(Number)
     IF Number >= 0 THEN
          LStr$ = RIGHT$(temp$, LEN(temp$) - 1)
     ELSE
          LStr$ = temp$
     END IF

END FUNCTION '

'*************************************************************************
'*   This function takes a long integer and converts it to a string with
'*   commas in it.
'*
'*************************************************************************
'
FUNCTION MakeCount$ (N AS LONG)
              
     Temp0$ = STR$(N)

     FOR I% = 1 TO LEN(Temp0$)
          IF INSTR("1234567890", MID$(Temp0$, I%, 1)) <> 0 THEN
               temp$ = temp$ + MID$(Temp0$, I%, 1)
          END IF
     NEXT I%
          
     IF LEN(temp$) > 3 THEN
          temp$ = LEFT$(temp$, LEN(temp$) - 3) + "," + RIGHT$(temp$, 3)
     END IF
     IF LEN(temp$) > 7 THEN
          temp$ = LEFT$(temp$, LEN(temp$) - 7) + "," + RIGHT$(temp$, 7)
     END IF

     MakeCount$ = RIGHT$("           " + temp$, 11)

END FUNCTION

'*********************************************************************
'*   This routine prompts the user for a new catalog.  If Catalog Error
'*   Checking is enabled and the catalog is invalid, it is set to an
'*   empty character.
'*
'*********************************************************************
'
SUB MenuCatalog (Catalog$)

LastCatalog$ = Status1.Catalog

     CALL PromptWithDefault("Enter Catalog: ", LastCatalog$, Catalog$)

     Catalog$ = UCASE$(LEFT$(Catalog$, 1))
    
     IF CatErr = 1 THEN
          IF IsValidCatalog%(Catalog$) = 0 THEN Catalog$ = " "
     END IF

     CALL SetCatalog(Catalog$)

END SUB'

SUB MenuFilter
    
     CALL Prompt("Filter Name:  ", TFilter$)
     FOR I% = 1 TO 10
          IF INSTR(Filter$(I%), TFilter$) THEN CALL SendFilter(I%)
     NEXT I%

END SUB

'*********************************************************************
'*   This sub sets the Internal fastmode integ time.
'*
'*
'*********************************************************************
'
SUB MenuFInteg (N AS INTEGER)

     'IF N = 1 THEN CALL SetFInteg(2)
     'IF N = 2 THEN CALL SetFInteg(5)
     'IF N = 3 THEN CALL SetFInteg(10)

END SUB

'*********************************************************************
'*   This sub sets the internal fastmode interval time.
'*
'*
'*********************************************************************
'
SUB MenuFInterval

     CALL Prompt("New FastMode Interval: ", temp$)
     IF VAL(temp$) < 1 THEN
          CALL Message("Mininum FInterval size: 1")
     ELSE
          IF VAL(temp$) > 10000 THEN
               CALL Message("Maximum FInterval size: 10000")
          ELSE
               CALL SetFInterval(INT(VAL(temp$)))
          END IF
     END IF

END SUB

'**********************************************************************
'*   This SUB does FastMode calculations and saves data.
'*
'*
'**********************************************************************
'
SUB MenuFRead (N%)

     IF Internal.FInterval < 1 THEN
          CALL Message("You must set your FIntervals before running a FastMode!")
          EXIT SUB
     END IF
   
     REDIM FModeData&(Internal.FInterval)
     cntr = 0
     Internal.FNum = 0
     t! = Status1.Integ
     t! = t! / 1000
     t! = t! + .001 'One ms overhead
  
     IF N% = 2 THEN
          CALL Message("Press any key to begin FastMode...")
          CALL WaitForKey(m$)
     END IF

     SELECT CASE N%
          CASE 0
               CALL Message("Testing FastMode.  Please wait...")
          CASE 1
               CALL Message("Running FastMode.  Please wait...")
          CASE 2
               CALL Message("Running Fastmode-B.  Press any key to end...")
     END SELECT

     DO
          Internal.FNum = Internal.FNum + 1
          Count# = FRead#
          FModeData&(Internal.FNum) = Count#
     LOOP UNTIL Internal.FNum >= Internal.FInterval
    
     IF N% = 2 THEN 'Fmode-B
          DO
               Count# = FRead#     'Loop while cycling data
               FOR I% = 1 TO Internal.FInterval
                    FModeData&(I% - 1) = FModeData&(I%)
               NEXT I%
               FModeData&(Internal.FInterval) = Count#
          LOOP UNTIL INKEY$ <> ""
     END IF
    
     EndTime! = UTimer#(TIMER)
     Internal.FMEndTime = EndTime!
    
     CALL Message("Done with FastMode.")
    
     SELECT CASE N%
          CASE 0         'Test FMode
               IF Interval.FInterval < 11 THEN t = 1 ELSE t = Internal.FInterval - 10
               FOR I% = t TO Internal.FInterval
                    TheTime# = EndTime! - ((Internal.FInterval * t!) - t! * I%)
                    CALL WriteCSF(TimerToTime$(TheTime#), I%, STR$(FModeData&(I%)))
                    CALL SetTime
               NEXT I%
         
          CASE 1         'FMode-A
               FOR I% = 1 TO Internal.FInterval
                    TheTime# = EndTime! - ((Internal.FInterval * t!) - t! * I%)
                    CALL WriteCSF(TimerToTime$(TheTime#), I%, STR$(FModeData&(I%)))
                    CALL SetTime
                    FastModeOut(0).Num = I%
                    FastModeOut(0).ITime = TimerToTime$(TheTime#)
                    FastModeOut(0).Counts = FModeData&(I%)
                    IF OutPutMode <> 0 THEN CALL WriteFastMode(FastModeOut(0))
               NEXT I%

          CASE 2         'FMode-B
               FOR I% = 1 TO Internal.FInterval
                    TheTime# = EndTime! - ((Internal.FInterval * t!) - t! * I%)
                    CALL WriteCSF(TimerToTime$(TheTime#), I%, STR$(FModeData&(I%)))
                    CALL SetTime
                    FastModeOut(0).Num = I%
                    FastModeOut(0).ITime = TimerToTime$(TheTime#)
                    FastModeOut(0).Counts = FModeData&(I%)
                    IF OutPutMode <> 0 THEN CALL WriteFastMode(FastModeOut(0))
               NEXT I%
          CASE ELSE
     END SELECT

     Internal.FNum = 0

END SUB

'*********************************************************************
'*   This sub runs a Free Fastmode data collection.
'*
'*
'*********************************************************************
'
SUB MenuFreeFast
    
     'CALL SendFModeB

END SUB

'*********************************************************************
'*   This routine changes the Scale to 1, 10 or 100 in the manual mode.
'*   In the Auto mode it checks to see if the scale switch is set to
'*   100 for proper operation.
'*
'*********************************************************************
'
SUB MenuGain
    IF AorM$ = "Y" THEN
        WHILE (INP(BaseAddress% + 2) AND 1) = 1
            CALL Message("SCALE switch not set to 100. Set SCALE to 100")
            CALL Delay(.5)
            CALL Message(" ")
            CALL Delay(.5)
        WEND
        CALL Prompt("Auto scale. Enter Scale? ", temp$)
    ELSE
        CALL Prompt("What is the current Scale setting? ", temp$)
    END IF
    SELECT CASE VAL(temp$)
       CASE 1
           CALL SetGain(1)
       CASE 10
           CALL SetGain(10)
       CASE 100
           CALL SetGain(100)
       CASE ELSE
           CALL Message("Scale must be either 1, 10, or 100!")
     END SELECT
END SUB

'*********************************************************************
'*   This routine prompts for an integeration time and checks it for
'*   validity.  Note: times are entered in seconds (ex: 1.5), NOT tenths
'*   of a second as they are used and stored throughout the rest of the
'*   program.
'*********************************************************************
'
SUB MenuInteg

     IF TermMode = 1 OR TermMode = 3 THEN
          CALL Prompt("New integration time: ", temp$)
          SELECT CASE VAL(temp$)
               CASE IS < 1
                    CALL Prompt("Integ times of less than one second require FastMode.  Proceed [Y/n]? ", YesNo$)
                    IF UCASE$(LEFT$(YesNo$, 1)) = "N" THEN
                         CALL Message("Integration time not changed.")
                    ELSE
                         CALL SendInteg(VAL(temp$))
                    END IF
               CASE 1 TO 32
                    CALL SendInteg(CINT(VAL(temp$)))
               CASE ELSE
                    CALL Message("Valid integration times:  0.001 to 32 seconds")
          END SELECT
     END IF

END SUB'

'*********************************************************************
'*   This menu routine calls the CheckInterval subroutine, with OType
'*   of 0 (for a range of 1 - 400) and Force of 1 (to ensure the user
'*   is prompted for a new interval)
'*
'*********************************************************************
'
SUB MenuInterval

     CALL CheckInterval(1)

END SUB

'*********************************************************************
'*   This routine also prompts for an object, however, the default is
'*   the last object/catalog entered, rather than the parameters.
'*
'*
'*********************************************************************
'
SUB MenuObject (Object$)

LastObject$ = Status1.Object

     CALL PromptWithDefault("Enter Object name: ", LastObject$, Object$)

     LastObject$ = Object$
     CALL SetObject(Object$)

END SUB '

'*********************************************************************
'*   This is the routine called when a user selects the READ option
'*   from the READ menu.  If an OutPutMode is active, the appropriate
'*   type of reading is begun, along with a check to see if a header
'*   needs to be written for a new file.
'*   Maybe some of the code could be moved to seperate subs.
'*********************************************************************
'
SUB MenuRead

     SELECT CASE OutPutMode  'OutPutMode
          CASE 0                        ' No file open, just do a visual
               IF IsSkyRead% = 0 THEN
                    IF IsFastMode% = 1 THEN
                         CALL Message("Running FastMode.")
                    ELSE
                         CALL MenuObject(temp$)
                         CurDL.Object = temp$
                         CALL MenuCatalog(temp1$)
                         CurDL.Catalog = temp1$
                         CALL Message("Running SlowMode.  Press ESC to abort...")
                    END IF
               ELSE
                    CALL Message("Running SKY read.  Press ESC to abort...")
               END IF
               IntervalPlace = 0
               DO
                    CALL SendRead
               LOOP UNTIL IntervalPlace >= Interval

          CASE 1, 2                       'Display SlowMode
               IF IsFastMode% THEN
                    IF NewFileQuery% <> 0 THEN
                         CALL WriteFastHeader
                    END IF
               ELSE
               IF NewFileQuery% <> 0 THEN
                    CALL Prompt("Observer name: ", ObsvName$)
                    CALL Prompt("Telescope: ", TeleName$)
                    CALL Prompt("Conditions: ", Conditions$)
                    CALL WriteSlowHeader(TeleName$, ObsvName$, Conditions$)
                    IF DataCompPrompted% = 0 THEN
                         NoDataComp% = 1
                         CALL Prompt("Use data file compression [y/N]? ", YesNo$)
                         IF UCASE$(LEFT$(YesNo$, 1)) = "Y" THEN NoDataComp% = 0
                         DataCompPrompted% = 1
                    END IF
               END IF
               END IF
               IF IsOListRead% = 1 THEN
                    CALL SetDataLine(Status1.Object, Status1.Catalog)
                    DO
                         CALL DoOList
                         DO
                              IF OLDone% = 0 THEN CALL SendRead
                         LOOP UNTIL IntervalPlace >= Interval
                         IF OLHalt% THEN EXIT DO
                    LOOP UNTIL EOF(3)
                    OLDone% = 0
                    CALL Message("OList Complete.")
                    IF OLHalt% THEN
                         OLHalt% = 0
                         CALL Message("OList Halted.  Data was retained.")
                    END IF
                    EXIT SUB
               END IF

               SELECT CASE IsSkyRead%
                    CASE 0
                         IF IsFastMode% THEN
                              CurDL.Object = Object$
                              CurDL.Catalog = Catalog$
                              IF Status1.Integ = 0 THEN CALL MenuInteg
                              CALL SetDataLine(Object$, Catalog$)
                              CALL Message("Running FastMode.")
                         ELSE
                              CALL MenuObject(Object$)
                              CurDL.Object = Object$
                              CALL MenuCatalog(Catalog$)
                              CurDL.Catalog = Catalog$
                              CALL CheckInterval(1)
                              IF Status1.Integ = 0 THEN CALL MenuInteg
                              CALL SetDataLine(Object$, Catalog$)
                              CALL Message("Running SlowMode.  Press ESC to abort...")
                         END IF
                    CASE 1
                         CALL Message("Running SKY read.  Press ESC to abort...")
                         CALL SetDataLine("SKY", " ")
                    CASE 2
                         CALL Message("Running SKYNEXT read.  Press ESC to abort...")
                         CALL SetDataLine("SKYNEXT", " ")
                    CASE 3
                         CALL Message("Running SKYLAST read.  Press ESC to abort...")
                         CALL SetDataLine("SKYLAST", " ")
               END SELECT
               DO
                    CALL SendRead
               LOOP UNTIL IntervalPlace >= Interval

     END SELECT

END SUB

'***************************************************************************
'*   This is a portion of the MenuRead subprogram adopted for the Read Test
'*   option under the Run menu.
'*
'*
'***************************************************************************
'
SUB MenuReadTest
    
     CurDL.Object = "*" + LEFT$(Status1.Object, LEN(Status1.Object) - 1)
     CurDL.Catalog = Status1.Catalog
     TestRead% = 1
     temp% = Status1.Interval
     CALL Message("Running Test Read...")
     CALL SendRead

END SUB

'*********************************************************************
'*   This sub runs a SKY read by first resetting the object name, then
'*   the catalog name, then a special data line, then calling a read.
'*
'*********************************************************************
'
SUB MenuSky (SkyType%)

     CALL SetSky(SkyType%)    'Fill in the "Sky Type" line of status win 1
     SkyRead% = SkyType%

     SELECT CASE SkyType%
          CASE 1
               SkyString$ = "SKY"
          CASE 2
               SkyString$ = "SKYNEXT"
          CASE 3
               SkyString$ = "SKYLAST"
     END SELECT

     CALL SetObject(SkyString$)    'Set the object name
     CALL SetCatalog(" ")          'SKYs have no catalog
    
     CurDL.Object = SkyString$     'Set up the data line
     CurDL.Catalog = " "

     CALL MenuRead                 'Call a read

     SkyRead% = 0

END SUB

'*********************************************************************
'*   This sub runs a timed fastmode data collection.
'*
'*
'*********************************************************************
'
SUB MenuTimedFast
    
     'CALL SendFModeA

END SUB

'*********************************************************************
'*   This sub clears the Message/Prompt window and prints a message
'*   in it.
'*
'*********************************************************************
'
SUB Message (Text$)

     CALL NewLine(PromptWin)
     CALL WriteCharsHL(PromptWin, LEFT$(" " + Text$, 78))

END SUB

'*********************************************************************
'*   This sub is responsible for alerting the user that the selected
'*   feature is not yet complete.  This is used for testing purposes
'*   only and should not get called in release versions of SSPDATAQ.EXE.
'*
'*********************************************************************
'
SUB NotYetImp

     CALL Message("This feature has not been implemented yet -- Beta")

END SUB

FUNCTION NumPos%

     NumPos% = SixOrTen%

END FUNCTION

'*********************************************************************
'*   This routine is the general purpose get user input routine for
'*   the entire program.  The prompt window is cleared, the new prompt
'*   written, and keyboard input sent to the prompt key handler.  An
'*   event loop is then entered, which terminates when TermMode <> 2,
'*   as is set on a return from the keyboard.
'*********************************************************************
'
SUB Prompt (PromptLine$, Result$)

     CALL NewLine(PromptWin)
     CALL WriteCharsHL(PromptWin, " " + PromptLine$)

     PromptResult$ = ""

     DO
          Char$ = INKEY$
          IF Char$ <> "" THEN
               SELECT CASE ASC(Char$)
                    CASE 8 'A backspace
                         IF LEN(PromptResult$) > 0 THEN
                              PromptResult$ = LEFT$(PromptResult$, LEN(PromptResult$) - 1)
                         END IF
                    CASE 13 'A carriage return
                         EXIT DO
                    CASE ELSE
                         PromptResult$ = PromptResult$ + Char$
               END SELECT
          END IF
    
          CALL LocRel(PromptWin, LEN(PromptLine$) + 2, 1)
          CALL WriteCharsHL(PromptWin, PromptResult$ + " ")
     LOOP
    
     Result$ = PromptResult$
     CALL Message("")

END SUB '

'*********************************************************************
'*   This is the prompt keyboard input handler.  It first checks for
'*   a carriage return (which ends the input), then a backspace (which
'*   deletes the last character), and finally for a valid, printing,
'*   character (which is added to the PromptResult$ and displayed).
'*********************************************************************
'
SUB PromptKey (TheKey$)

     SELECT CASE ASC(TheKey$)
          CASE 13
               CALL NewLine(PromptWin)
               TermMode = 3
          CASE 8
               IF LEN(PromptResult$) > 0 THEN     ' Make sure theres something
                                                  ' to delete
                    PromptResult$ = LEFT$(PromptResult$, LEN(PromptResult$) - 1)
                    CALL BackSpace(PromptWin)
                    CALL WriteChars(PromptWin, " ")
                    CALL BackSpace(PromptWin)
               END IF
          CASE 32 TO 127
               PromptResult$ = PromptResult$ + TheKey$
               CALL WriteCharsHL(PromptWin, TheKey$)
     END SELECT

END SUB '

'*********************************************************************
'*   This is technically not one of the Prompt family of functions.
'*   This routine prompts for the Catalog and Object names, using
'*   defaults supplied by the OList.
'*
'*********************************************************************
'
SUB PromptLObject (Object$, Catalog$)

     CALL PromptWithDefault("Enter Object name: ", Object$, Object$)
     CALL SetObject(Object$)
     CALL SetCatalog(Catalog$)
     CALL MenuCatalog(Catalog$)
     CALL SetCatalog(Catalog$)

END SUB'

'*********************************************************************
'*   This routine is very similiar to the basic Prompt, except a default
'*   is displayed in [] after the prompt and is copied into the Result$
'*   if nothing is entered.
'*
'*********************************************************************
'
SUB PromptWithDefault (PromptLine$, Default$, Result$)

     CALL NewLine(PromptWin)
     CALL WriteCharsHL(PromptWin, " " + PromptLine$ + "[" + Default$ + "]  ")

     TermMode = 2
     PromptResult$ = ""

     DO
          Char$ = INKEY$
          IF Char$ <> "" THEN
               SELECT CASE ASC(Char$)
                    CASE 8 'A backspace
                         IF LEN(PromptResult$) > 0 THEN
                              PromptResult$ = LEFT$(PromptResult$, LEN(PromptResult$) - 1)
                         END IF
                    CASE 13 'A carriage return
                         EXIT DO
                    CASE ELSE
                         PromptResult$ = PromptResult$ + Char$
               END SELECT
          END IF
          CALL LocRel(PromptWin, LEN(PromptLine$) + 5 + LEN(Default$), 1)
          CALL WriteCharsHL(PromptWin, PromptResult$ + " ")
     LOOP

     IF PromptResult$ = "" THEN
          Result$ = Default$
     ELSE
          Result$ = PromptResult$
     END IF

     CALL Message("")

     TermMode = 3

END SUB '

'*********************************************************************
'*   This is the routine that sets the exit flag from the event loop.
'*   If for any reason a quit needs to be prevented, consider putting
'*   the code here.
'*
'*********************************************************************
'
SUB Quit

     Running = 0
     IdleMode = 1
     ON ERROR GOTO NoFileAccess
     CLOSE #5
     ON ERROR GOTO 0
     CALL QBMouse(2, 0, 0, 0)
     COLOR 7, 0
     'cls

END SUB '

'*************************************************************************
'*   This redraws all the windows and parameters on the screen.  This
'*   routine should be called by ToggleNiteMode and DoShell, when
'*   implemented.
'*
'*************************************************************************
'
SUB RestoreScreen
    
     CALL QBMouse(2, 0, 0, 0)
    
     COLOR 7, 0
     CLS

     CALL InitWindows
     CALL InitPullDown
   
     IF NiteMode$ = "Y" THEN FC% = 4 ELSE FC% = 7
     IF NiteMode$ = "Y" THEN BC% = 0 ELSE BC% = 1
    
     StatusWin1 = NewWindow(1, 19, 55, 25, BC%, FC%, "Instrument Status")
     StatusWin3 = NewWindow(56, 19, 80, 25, BC%, FC%, "Time")
     PromptWin = NewWindow(1, 16, 80, 18, BC%, FC%, "Message")
    
         
     CountStatusWin = NewWindow(1, 2, 80, 15, BC%, FC%, "Count Status")

'Re-write the CS window
     IF CSLines$(1) <> "" THEN
          CALL LocRel(CountStatusWin, 1, 1)
          CALL WriteCharsHL(CountStatusWin, " DATE      TIME      CAT  OBJECT   FILTER        COUNT         INTEG  GAIN")
          FOR I% = 1 TO 11
               CALL LocRel(CountStatusWin, 1, I% + 1)
               CALL WriteCharsHL(CountStatusWin, CSLines$(I%))
          NEXT I%
     END IF
    
    
     CALL DrawStatusWin1
     CALL DrawStatusWin3
     CALL SetTime

     CALL SetObject(Status1.Object)
     CALL SetCatalog(Status1.Catalog)
     CALL SetSky(Status1.SkyType)
     CALL SetAutoSky  'This is done twice so that AutoSky and AutoObject
     CALL SetAutoSky  'retain their values but still get displayed
     CALL SetAutoObject
     CALL SetAutoObject
     temp = Status1.Gain
     CALL SetGain(temp)
     temp = Interval
     CALL SetInterval(temp)
     CALL SetInteg(Status1.Integ)
     CALL SetFiltPos(Status1.WheelA)

     QBMouse 1, 0, 0, 0           'show mouse cursor
     QBMouse 10, 0, &H7000, 3844   'set mouse cursor


END SUB '

SUB SelectFilter (Name$, FoundIt%)

    FoundIt% = 1
    IF FindFilter1%(Name$) = 0 THEN FoundIt% = 0 ELSE CALL SendFilter(FindFilter1%(Name$))

END SUB

'*********************************************************************
'*   This routine displays the actual filter temperature setting.  If
'*   a over/under temperature check is desired, this is where it should
'*   be placed.
'*
'*********************************************************************
'
SUB SetAFilt (N)

     Status1.Filter = N

     CALL LocRel(StatusWin2, 14, 6)
     IF N >= 0 THEN
          CALL WriteCharsHL(StatusWin2, "+")
     ELSE
          CALL WriteCharsHL(StatusWin2, "-")
     END IF

     temp$ = STR$(ABS(N))
     IF INSTR(temp$, ".") = 0 THEN
          temp$ = temp$ + ".0"
     END IF
     temp$ = RIGHT$("  " + temp$, 4)
     CALL LocRel(StatusWin2, 15, 6)
     CALL WriteCharsHL(StatusWin2, temp$)

END SUB '

'*********************************************************************
'*   This routine toggles and displays the current AutoObject status,
'*   ON or OFF.
'*
'*
'*********************************************************************
'
SUB SetAutoObject

     IF Status1.AutoObject = 1 THEN
          Status1.AutoObject = 0
          CALL LocRel(StatusWin1, 14, 4)
          CALL WriteCharsHL(StatusWin1, "OFF")

     ELSE
          Status1.AutoObject = 1
          Status1.AutoSky = 1
          CALL LocRel(StatusWin1, 14, 4)
          CALL WriteCharsHL(StatusWin1, "ON ")
          CALL LocRel(StatusWin1, 14, 5)
          CALL WriteCharsHL(StatusWin1, "ON ")
     
     END IF

END SUB '

'*********************************************************************
'*   This routine toggles and displays the current AutoSky status, ON
'*   or OFF.
'*
'*
'*********************************************************************
'
SUB SetAutoSky

     IF Status1.AutoSky = 1 THEN
          Status1.AutoSky = 0
          CALL LocRel(StatusWin1, 14, 5)
          CALL WriteCharsHL(StatusWin1, "OFF")

     ELSE
          Status1.AutoSky = 1
          CALL LocRel(StatusWin1, 14, 5)
          CALL WriteCharsHL(StatusWin1, "ON ")
    
     END IF


END SUB '

'*********************************************************************
'*   This routine truncates, sets, and displays the current Catalog.
'*
'*
'*
'*********************************************************************
'
SUB SetCatalog (Catalog$)

     Status1.Catalog = LEFT$(Catalog$ + " ", 1)

     CALL LocRel(StatusWin1, 39, 2)
     CALL WriteCharsHL(StatusWin1, Status1.Catalog)

END SUB '

'*********************************************************************
'*   This routine toggles Catalog Error Checking on or off.
'*
'*
'*
'*********************************************************************
'
SUB SetCatErr

     IF CatErrCheck = 0 THEN CatErrCheck = 1 ELSE CatErrCheck = 0

END SUB '

'*********************************************************************
'*   This sub is not really one of the Set functions.  It is called
'*   when the user initializes the comm port from the menu
'*
'*********************************************************************
'
SUB SetCommDefaults (Port$, Baud$)

     DefaultPort$ = Port$
     DefaultBaud$ = Baud$

END SUB

'*********************************************************************
'*   This routine does whatever needs to be done when a count is read,
'*   including displaying it, writing it to a file, and starting the
'*   next count operation.  This routine is derived from the SetCount
'*   function and may still have some problems.
'*********************************************************************
'
SUB SetCount2 (N AS LONG)

     CALL SetTime
     CountStatus.DCount = N
     CountStatus.ITime = Status3.UTime
     CountStatus.IDate = Status3.UDate

     IF IsTestRead% THEN
          temp$ = MakeCount$(N)
          CALL WriteCS(temp$)
          TestRead% = 0
          CALL Message("Test Read complete.")
          EXIT SUB
     END IF
    
     SELECT CASE OutPutMode
          CASE 0                   'Normal display only reading
               temp$ = MakeCount$(N)
               CALL WriteCS(temp$)
               IF AbortRead% THEN
                    CALL Message("Interval Reading Aborted.")
                    AbortRead% = 0
                    EXIT SUB
               END IF
               IntervalPlace = IntervalPlace + 1
               IF IntervalPlace >= Interval THEN CALL Message("Interval Readings Complete.") ELSE CALL SendRead
         
          CASE 1, 2                   ' Display and write to a file

               temp$ = MakeCount$(N)
               CALL WriteCS(temp$)
               IF AbortRead% THEN
                    PRINT #1, CHR$(3)
                    CALL Message("Interval Reading Aborted.")
                    AbortRead% = 0
                    EXIT SUB
               END IF

               IF NoDataComp% = 0 THEN
                    SELECT CASE CurDL.CurInteg ' How far into the line?
                         CASE 0
                              CurDL.IDate = CountStatus.IDate
                              CurDL.ITime = CountStatus.ITime
                              CurDL.Gain = Status1.Gain
                              CurDL.C1 = CountStatus.DCount
                         CASE 1
                              CurDL.C2 = CountStatus.DCount
                         CASE 2
                              CurDL.C3 = CountStatus.DCount
                         CASE 3
                              CurDL.C4 = CountStatus.DCount
                    END SELECT
               ELSE
                    CurDL.IDate = CountStatus.IDate
                    CurDL.ITime = CountStatus.ITime
                    CurDL.Gain = Status1.Gain
                    CurDL.C1 = CountStatus.DCount
                    CurDL.C2 = 0
                    CurDL.C3 = 0
                    CurDL.C4 = 0
                    CurDL.CurInteg = 3
               END IF

               CurDL.CurInteg = CurDL.CurInteg + 1
               IntervalPlace = IntervalPlace + 1
             
               IF (CurDL.CurInteg > 3) AND (IntervalPlace < Interval) THEN
' A full line is done, so write it to the file
                    CALL WriteSlowLine(CurDL)
                    CurDL.CurInteg = 0
                    CurDL.C1 = 0
                    CurDL.C2 = 0
                    CurDL.C3 = 0
                    CurDL.C4 = 0
               END IF

               IF IntervalPlace >= Interval THEN
                    IF IsOListRead% = 0 THEN
' The full interval is done, so get comments and write the line to the file
                         CALL AskForComments
                         CALL WriteSlowLine(CurDL)
                         CALL Message("Interval Reading Complete.")
                    ELSE
                         NotAStart% = 1
                         IF EOF(3) = 0 THEN
' We're not done with the OList yet, so start the next interval
                              'CALL DoOList
                              EXIT SUB
                         ELSE
                              ON ERROR GOTO OListHalted:
                              CALL AskForComments
                              CALL WriteSlowLine(CurDL)
                              ON ERROR GOTO 0
                              CALL Message("OList Complete.")
                         END IF
                    END IF
               END IF

     END SELECT

END SUB '

'*********************************************************************
'*   This routine is NOT one of the set routines for displaying SSP
'*   output.  It is a helper routine to set up a new dataline for
'*   observations.
'*
'*********************************************************************
'
SUB SetDataLine (Object$, Catalog$)


     CALL SetDLObject(Object$, Catalog$)

     CurDL.Gain = 1

     CurDL.CurInteg = 0
     CurDL.C1 = 0
     CurDL.C2 = 0
     CurDL.C3 = 0
     CurDL.C4 = 0


END SUB  '

SUB SetDLObject (Object$, Catalog$)
   
     CurDL.Object = Object$
     CurDL.Catalog = Catalog$
    
     temp$ = Status1.FiltName
     DO
          IF RIGHT$(temp$, 1) = " " THEN
               temp$ = LEFT$(temp$, LEN(temp$) - 1)
          ELSE
               EXIT DO
          END IF
     LOOP

     SELECT CASE LEN(temp$)
          CASE 1
               RealFilterName$ = " " + temp$
          CASE 2
               RealFilterName$ = temp$
          CASE ELSE
               SELECT CASE temp$
                    CASE "Dark"
                         RealFilterName$ = " d"
                    CASE ELSE
                         RealFilterName$ = LEFT$(temp$, 2)
               END SELECT
     END SELECT

     CurDL.Filter = RealFilterName$
     CurDL.Integ = Status1.Integ
    
     IntervalPlace = 0

END SUB

SUB SetFileType

     SELECT CASE Fyle%
          CASE 0
               Text$ = "None    "
          CASE 1
               Text$ = "FastMode"
          CASE 2
               Text$ = "SlowMode"
     END SELECT

     CALL LocRel(StatusWin1, 39, 5)
     CALL WriteCharsHL(StatusWin1, Text$)

END SUB

'***********************************************************************
'*  This routine sets the user designated filter name in StatusWin1.
'*
'*
'*
'***********************************************************************
'
SUB SetFilterName (FiltName$)
  
     Status1.FiltName = LEFT$(FiltName$ + "            ", 12)
     CALL LocRel(StatusWin1, 39, 3)
     CALL WriteCharsHL(StatusWin1, LEFT$(FiltName$ + "            ", 12))

END SUB '

'*********************************************************************
'*   This processes a filter home by setting the approprate filter
'*   position to 1.  A flag could also be set here to assure that
'*   the filter is homed before anything is used.
'*
'*********************************************************************
'
SUB SetFiltHome

     CALL SetFiltPos(1)

END SUB '

'*********************************************************************
'*   This routine updates the record and screen display of a current
'*   filter position.  F1 is the new position.
'*
'*********************************************************************
'
SUB SetFiltPos (F1%)

     Status1.WheelA = F1%
     'CALL LocRel(StatusWin1, 14, 4)
     'CALL WriteCharsHL(StatusWin1, LEFT$(FiltNames$(Status1.WheelA) + "            ", 12))
     CALL SetFilterName(Filter$(F1%))

END SUB '

SUB SetFInterval (Interval%)

     Internal.FInterval = Interval%

END SUB

'*********************************************************************
'*   This is where code to record and display the gain setting should
'*   go.  It would most probably belong in the Status1 window, as it
'*   should be written to the output file. In Auto scale mode the scale
'*   on the instrument is set here.
'*********************************************************************
'
SUB SetGain (N)

     IF N = 100 THEN
          Status1.Gain = 100
          CALL LocRel(StatusWin1, 14, 3)
          CALL WriteCharsHL(StatusWin1, "100")
          IF AorM$ = "Y" THEN OUT BaseAddress% + 1, 2
     END IF
     IF N = 10 THEN
          Status1.Gain = 10
          CALL LocRel(StatusWin1, 14, 3)
          CALL WriteCharsHL(StatusWin1, "10 ")
          IF AorM$ = "Y" THEN OUT BaseAddress% + 1, 6
     END IF
     IF N = 1 THEN
          Status1.Gain = 1
          CALL LocRel(StatusWin1, 14, 3)
          CALL WriteCharsHL(StatusWin1, "1  ")
          IF AorM$ = "Y" THEN OUT BaseAddress% + 1, 3
     END IF
     IF N <> 100 AND N <> 10 AND N <> 1 THEN
          Status1.Gain = 0
     END IF

END SUB

'*********************************************************************
'*   This is a wrapper function for the Idle variable.  This should
'*   be called whenever it becomes appropriate to send idle messages
'*   to the SSP.
'*
'*********************************************************************
'
SUB SetIdle

     Idle = 1

END SUB '

'*********************************************************************
'*   This routine processes a new integration time and displays and
'*   records it.
'*
'*
'*********************************************************************
'
SUB SetInteg (N%)

    
' NOTE: the recorded value in Status1 is in thousandths of a second, NOT seconds.
     IF N% = 0 THEN N% = 1000
     Status1.Integ = N%
        
     temp$ = STR$(N% / 1000)
     temp$ = RIGHT$(temp$, LEN(temp$) - 1)
    
     IF INSTR(temp$, ".") = 0 THEN
          temp$ = temp$ + ".0"
     ELSE
         IF INSTR(temp$, ".") = 1 THEN temp$ = "0" + temp$
     END IF

     temp$ = RIGHT$(temp$, 5)

     CALL LocRel(StatusWin1, 14, 2)
     CALL WriteCharsHL(StatusWin1, temp$ + "    ")

END SUB

SUB SetInterval (N)

'    Do the set interval things here
     Interval = N
     IntervalPlace = 0
     Status1.Interval = Interval

'    Cut the leading spaces off the interval count
     temp$ = STR$(Interval)
     FOR I = 1 TO LEN(temp$)
       IF LEFT$(temp$, 1) = " " THEN temp$ = RIGHT$(temp$, LEN(temp$) - 1)
     NEXT I
     CALL LocRel(StatusWin1, 14, 1)
     CALL WriteCharsHL(StatusWin1, temp$ + "  ")

END SUB '

'*********************************************************************
'*   This routine sets and displays a new object name.
'*
'*
'*
'*********************************************************************
'
SUB SetObject (Object$)
    
     Status1.Object = LEFT$((Object$ + "          "), 10)

     CALL LocRel(StatusWin1, 39, 1)
     CALL WriteCharsHL(StatusWin1, Status1.Object)

END SUB '

'*********************************************************************
'*   This is a dummy routine with the same purpose as SetFilt(N)
'*
'*
'*
'*********************************************************************
'
SUB SetPmt (N)

'    Do the Set PMT cooler temp things here

END SUB '

'*********************************************************************
'*   This routine sets and displays a new sky type.
'*
'*
'*
'*********************************************************************
'
SUB SetSky (SkyType%)

     SELECT CASE SkyType%
          CASE 1
               SkyText$ = "SKY    "
          CASE 2
               SkyText$ = "SKYNEXT"
          CASE 3
               SkyText$ = "SKYLAST"
          CASE ELSE
               CALL AbortErr("SetSky:  Invalid sky type!  (" + STR$(SkyType%) + ")")
     END SELECT

     Status1.SkyType = SkyType%
     CALL LocRel(StatusWin1, 39, 4)
     CALL WriteCharsHL(StatusWin1, SkyText$)

END SUB '

'**************************************************************************
'*  This quirky bit of code sets and prints all time-related variables for
'*  the third status window.  Things accounted for are: difference between
'*  Local Time and Universal Time, computer's clock orientation, no more than
'*  24 hours in a day, no negative times-of-day, date differences, month
'*  differences, year differences, leap years, etc.
'*
'*  Yes, I know code this insane should be illegal.  But what can I say?
'*  Blame the Sumerians.
'**************************************************************************
'
SUB SetTime

   temp$ = LEFT$(GetTime$, 8)
   Hours% = VAL(MID$(temp$, 1, 2))         'these are our working variables
   Minutes% = VAL(MID$(temp$, 4, 2))
   Seconds% = VAL(MID$(temp$, 7, 2))
  
   months% = VAL(MID$(DATE$, 1, 2))
   days% = VAL(MID$(DATE$, 4, 2))
   years% = VAL(MID$(DATE$, 7, 4))

   IF UTOrLoc$ = "UT" THEN          '<--  if this is true, then the
     Status3.UTime = temp$                'computer's clock is set to
     Lhours% = Hours% + UTDif%            'universal time
    
     IF Lhours% > 23 THEN
          Modifier = 1
          Lhours% = Lhours% - 24          'from that we calculate local time
     END IF
    
     IF Lhours% < 0 THEN
          Modifier = -1
          Lhours% = 24 + Lhours%
     END IF                               'and add leading zeros
     Lhours$ = "00" + RIGHT$(STR$(Lhours%), LEN(STR$(Lhours%)) - 1)
     Minutes$ = "00" + RIGHT$(STR$(Minutes%), LEN(STR$(Minutes%)) - 1)
     Seconds$ = "00" + RIGHT$(STR$(Seconds%), LEN(STR$(Seconds%)) - 1)
     Status3.LTime = RIGHT$(Lhours$, 2) + ":" + RIGHT$(Minutes$, 2) + ":" + RIGHT$(Seconds$, 2)
    
     'Time calculations are done; now, on to the date

     IF Modifier = 1 THEN
          days% = days% + 1
          IF days% > MonthData(months%) THEN
               days% = 1
               months% = months% + 1
               IF months% = 12 THEN
                    months% = 1
                    years% = years + 1
               END IF
          END IF
     END IF
    
     IF Modifier = -1 THEN
          days% = days% - 1
          IF days% < 1 THEN
               months% = months% - 1
               IF months% < 1 THEN
                    months% = 12
                    years% = years - 1
               END IF
               days% = MonthData(months%)
          END IF
     END IF

     Status3.UDate = DATE$
     LMonths$ = RIGHT$("00" + RIGHT$(STR$(months%), LEN(STR$(months%)) - 1), 2)
     LDays$ = RIGHT$("00" + RIGHT$(STR$(days%), LEN(STR$(days%)) - 1), 2)
     LYears$ = RIGHT$(STR$(years%), 4)

     Status3.LDate = LMonths$ + "-" + LDays$ + "-" + LYears$

   ELSE                            'The computer is set to local time
     Status3.LTime = temp$
     Uhours% = Hours% + UTDif%
    
     IF Uhours% > 23 THEN
          Modifier = 1
          Uhours% = Uhours% - 24
     END IF
    
     IF Uhours% < 0 THEN
          Modifier = -1
          Uhours% = 24 + Uhours%
     END IF
    
     Uhours$ = "00" + RIGHT$(STR$(Uhours%), LEN(STR$(Uhours%)) - 1)
     Minutes$ = "00" + RIGHT$(STR$(Minutes%), LEN(STR$(Minutes%)) - 1)
     Seconds$ = "00" + RIGHT$(STR$(Seconds%), LEN(STR$(Seconds%)) - 1)
     Status3.UTime = RIGHT$(Uhours$, 2) + ":" + RIGHT$(Minutes$, 2) + ":" + RIGHT$(Seconds$, 2)
  
     'Time calculations are done; now for the date
    
     IF Modifier = 1 THEN
          days% = days% + 1
          IF days% > MonthData(months%) THEN
               days% = 1
               months% = months% + 1
               IF months% = 12 THEN
                    months% = 1
                    years% = years + 1
               END IF
          END IF
     END IF
   
     IF Modifier = -1 THEN
          days% = days% - 1
          IF days% < 1 THEN
               months% = months% - 1
               IF months% < 1 THEN
                    months% = 12
                    years% = years - 1
               END IF
               days% = MonthData(months%)
          END IF
     END IF

     UMonths$ = RIGHT$("00" + RIGHT$(STR$(months%), LEN(STR$(months%)) - 1), 2)
     UDays$ = RIGHT$("00" + RIGHT$(STR$(days%), LEN(STR$(days%)) - 1), 2)
     UYears$ = RIGHT$(STR$(years%), 4)

     Status3.UDate = UMonths$ + "-" + UDays$ + "-" + UYears$
     Status3.LDate = DATE$

   END IF

   CALL LocRel(StatusWin3, 12, 1)               'Now that we have the values,
   CALL WriteCharsHL(StatusWin3, Status3.UTime) 'we print them
   CALL LocRel(StatusWin3, 12, 2)
   CALL WriteCharsHL(StatusWin3, Status3.UDate)
   CALL LocRel(StatusWin3, 12, 4)
   CALL WriteCharsHL(StatusWin3, Status3.LTime)
   CALL LocRel(StatusWin3, 12, 5)
   CALL WriteCharsHL(StatusWin3, Status3.LDate)

END SUB '

'*********************************************************************
'*   This gets all the time options from the user and writes them to the
'*   config file
'*
'*
'*********************************************************************
'
SUB SetTimeOptions

     CALL NewLine(PromptWin)
     CALL Prompt("Is your computer set to Universal or Local time? [U/l]  ", temp$)
     IF UCASE$(LEFT$(temp$, 1)) <> "L" THEN
           UTOrLoc$ = "UT"
           CALL Prompt("What is the difference (in hours) between Local time and Universal time?  ", temp$)
         ELSE
           UTOrLoc$ = "LT"
           CALL Prompt("What is the difference (in hours) between Universal time and Local time?  ", temp$)
     END IF

     UTDif% = INT(VAL(temp$))
    
     IF UTDif% > 23 THEN UTDif% = UTDif% MOD 24
     IF UTDif% < -23 THEN UTDif% = UTDif% MOD 24
    
     CALL WriteCfg

END SUB '

'*********************************************************************
'*   This is the sub that displays the info window for the "About"
'*   option under the setup menu.  This should include name, version,
'*   EPROM version, and Optec information.
'*
'*********************************************************************
'
SUB ShowAbout

     CALL QBMouse(2, 0, 0, 0)
     AboutWin = NewWindow(10, 2, 70, 17, 0, 7, "About SSPDATAQ.EXE")
     CALL LocRel(AboutWin, 25, 2)
     CALL WriteCharsHL(AboutWin, "SSPDATAQ.EXE")
     CALL LocRel(AboutWin, 27, 3)
     CALL WriteCharsHL(AboutWin, "v2.00")
     CALL LocRel(AboutWin, 14, 4)
     CALL WriteChars(AboutWin, "intended for use with instruments")
     CALL LocRel(AboutWin, 14, 5)
     CALL WriteChars(AboutWin, "SSP-3, SSP-3A, SSP-5, or SSP-5A.")
     CALL LocRel(AboutWin, 25, 7)
     CALL WriteCharsHL(AboutWin, "Optec, Inc.")
     CALL LocRel(AboutWin, 22, 8)
     CALL WriteChars(AboutWin, "199 Smith Street")
     CALL LocRel(AboutWin, 22, 9)
     CALL WriteChars(AboutWin, "Lowell, MI 49331")
     CALL LocRel(AboutWin, 27, 10)
     CALL WriteChars(AboutWin, "U.S.A.")
     CALL LocRel(AboutWin, 10, 11)
     CALL WriteChars(AboutWin, "(616) 897-9351  -  FAX: (616) 897-8229")
     CALL LocRel(AboutWin, 18, 12)
     CALL WriteChars(AboutWin, "E-Mail:  info@optecinc.com")
     CALL LocRel(AboutWin, 14, 13)
     CALL WriteChars(AboutWin, "Web Site:  http://www.optecinc.com")

     CALL WaitForKey(temp$)
     CALL RestoreScreen

END SUB '

'************************************************************************
'*   This spiffy little routine displays the help file (as acquired line-
'*   by-line from the formatted help file) allowing the user to scroll
'*   forward or backward within the file.  All pseudocommand processing
'*   is done within this sub.
'************************************************************************
'
SUB ShowHelp

'Open the Help file
     ON ERROR GOTO FileError
     OPEN "SSPDATAQ.hlp" FOR RANDOM AS #5 LEN = 123
     ON ERROR GOTO 0

'We don't want the mouse to be available during Help display
     CALL QBMouse(2, 0, 0, 0)

'Skip the topics
     StartLine% = 1
     GET #5, StartLine%, Line$
     DO UNTIL LEFT$(Line$, 3) <> "@T>"
          StartLine% = StartLine% + 1
          GET #5, StartLine%, Line$
     LOOP

'Now we initialise and draw the window
     HelpWin = NewWindow(1, 2, 80, 17, 0, 7, "Help on SSPDATAQ.EXE")
     COLOR 7, 0
     IF NiteMode$ = "Y" THEN COLOR 4, 0
     LOCATE 17, 20
     PRINT CHR$(181) + " <B>ack page      <F>orward page     <Q>uit " + CHR$(198)

'Now we initialise our working variables
     cntr = StartLine% - 1
     lines% = 0
     BlankLine$ = "                                                                            "
    
'Now we enter the line-printing DO loop
     DO
          extra% = 0
          cntr = cntr + 1
          GET #5, cntr, Text$
          lines% = lines% + 1
          CALL LocRel(HelpWin, 1, lines%)
          CALL WriteChars(HelpWin, " ")

'This is where help file pseudocommands are processed
     CType% = 1
     FOR I% = 1 TO LEN(Text$)
          Char$ = LEFT$(Text$, 1)
          Text$ = RIGHT$(Text$, LEN(Text$) - 1)
          IF Char$ = "@" THEN CType% = 0
               SELECT CASE CType%
                    CASE 0
                         SELECT CASE LEFT$(Text$, 2)
                              CASE "B>"
                                   CType% = 2
                                   Text$ = RIGHT$(Text$, LEN(Text$) - 2)
                                   I% = I% + 2
                              CASE "EO"
                                   LastLine% = 1
                             
                              'More pseudocommands can be added here
                       
                              CASE ELSE
                                   CType% = 1
                                   CALL WriteChars(HelpWin, Char$)
                         END SELECT
                    CASE 1
                         CALL WriteChars(HelpWin, Char$)
                    CASE 2
                         IF Char$ = "<" THEN
                              CType% = 1
                         ELSE
                              CALL WriteCharsHL(HelpWin, Char$)
                         END IF
               END SELECT
     NEXT I%
              
'If this is the last line in the file, we want to fill the rest of the window
'up with blank lines
          IF LastLine% THEN
               IF lines% < 14 THEN
                    DO
                         CALL LocRel(HelpWin, 1, lines%)
                         CALL WriteChars(HelpWin, BlankLine$)
                         lines% = lines% + 1
                         extra% = extra% + 1
                    LOOP UNTIL lines% = 14
               END IF
          END IF

'If we are at the end of a page, then we wait for a keypress
          IF lines% > 12 THEN
               lines% = 0
               CALL WaitForKey(temp$)
               SELECT CASE UCASE$(temp$)
                    CASE "B"
                         IF cntr > 27 THEN cntr = cntr - (26 - (extra% - 1)) ELSE cntr = StartLine% - 1
                         IF LastLine% THEN LastLine% = 0
                    CASE "F"
                         IF LastLine% THEN cntr = cntr - (14 - extra%)
                         LastLine% = 0
                    CASE "T"
                         CALL DrawBox(10, 3, 42, StartLine% + 3, 0)
                         LOCATE 3, 15
                         COLOR 7, 0
                         PRINT " Help Topics "
                         COLOR 15, 0
                         FOR I% = 1 TO StartLine% - 1
                              GET #5, I%, TopicName$
                              TopicName$ = UnTopic$(TopicName$)
                              LOCATE 3 + I%, 12
                              PRINT STR$(I%) + ". " + TopicName$
                         NEXT I%
                         CALL WaitForKey(Num$)
                         IF VAL(Num$) > 0 AND VAL(Num$) < StartLine% THEN
                              GET #5, VAL(Num$), TopicLine$
                              cntr = VAL(MID$(TopicLine$, INSTR(TopicLine$, ".") + 1)) + (StartLine% - (VAL(Num$) + 1))
                              LastLine% = 0
                         ELSE
                              IF LastLine% THEN extra% = extra% - 1
                              cntr = cntr - (13 - extra%)
                              LastLine% = 0
                         END IF
                    CASE "Q"
                         EXIT DO
                    CASE CHR$(27)  'An escape keypress
                         EXIT DO
                    CASE ELSE
                         IF LastLine% THEN extra% = extra% - 1
                         cntr = cntr - (13 - extra%)
                         LastLine% = 0
               END SELECT
          END IF
    
     LOOP
   
     CLOSE #5

     CALL RestoreScreen

END SUB

FUNCTION SSPType%

     SSPType% = HardWare%
     '1 = SSP-3
     '2 = SSP-3A
     '3 = SSP-5
     '4 = SSP-5A

END FUNCTION

'*********************************************************************
'*   This sub writes the temporary "To go" line of Status window 3.
'*   If it recieves a single space, it clears the line.  It is
'*   currently only called in Timed FMode.
'*********************************************************************
'
SUB Status3TimeLeft (TimeLeft$)
    
     CALL LocRel(StatusWin3, 2, 7)
     CALL WriteChars(StatusWin3, "  To go:")
    
     CALL LocRel(StatusWin3, 12, 7)
     CALL WriteCharsHL(StatusWin3, TimeLeft$)

     IF TimeLeft$ = " " THEN
          CALL LocRel(StatusWin3, 2, 7)
          CALL WriteChars(StatusWin3, "                     ")
     END IF

END SUB

'*********************************************************************
'*   This variation of the GetTime function simply converts any single
'*   precision number to a valid time string in hh:mm:ss.ssss format.
'*
'*********************************************************************
'
FUNCTION TimerToTime$ (NumSecs AS DOUBLE)

     DIM Time AS DOUBLE, Result$, Hours AS INTEGER, Minutes AS INTEGER, Seconds AS INTEGER
     DIM Thousands AS INTEGER

     Time = NumSecs

     Hours = INT(Time / 3600)
     Time = Time - (Hours * 3600!)

     Minutes = INT(Time / 60)
     Time = Time - (Minutes * 60)

     Seconds = INT(Time)
     Time = Time - Seconds

     Thousands = INT(Time * 1000)

     TimerToTime$ = RIGHT$("0" + LStr$(Hours), 2) + ":" + RIGHT$("0" + LStr$(Minutes), 2) + ":" + RIGHT$("0" + LStr$(Seconds), 2) + "." + RIGHT$("00" + LStr$(Thousands), 3)

END FUNCTION

'*********************************************************************
'*   This routine toggles Night vision mode on or off.
'*   Why is the flag NiteMode a string and not a simple integer 1 or 0?
'*   Because variables for some reason seem to have a tendency to get pointed
'*   to it.  In other words, I might change IsAppend% to 1, and all of a
'*   sudden find myself in Night Mode.  Changing NiteMode to a string seems to
'*   solve this problem.  Really weird; I am almost certain that this is a
'*   compiler error.
'*********************************************************************
'
SUB ToggleNite
  
     IF NiteMode$ = "N" THEN NiteMode$ = "Y" ELSE NiteMode$ = "N"
     CALL WriteCfg
     CALL RestoreScreen

END SUB '

'*********************************************************************
'*   This function simply returns the number of seconds since midnight
'*   truncated to three decimal places (for use with FastMode).
'*
'*********************************************************************
'
FUNCTION TruncTimer!

     NumSecs$ = STR$(TIMER)
     IntSeconds& = INT(TIMER)
     TruncTimer! = IntSeconds& + VAL(MID$(NumSecs$ + "000", INSTR(NumSecs$, "."), 3))

END FUNCTION

FUNCTION UnTopic$ (TheString$)

     TheString$ = LEFT$(TheString$, INSTR(TheString$, "<") - 1)
     TheString$ = RIGHT$(TheString$, LEN(TheString$) - INSTR(TheString$, ">"))
     UnTopic$ = TheString$

END FUNCTION

'********************************************************************
'*   This function is used in the ReadFRead function in order to take
'*   UT differences into account while doing an FREAD.
'*
'********************************************************************
'
FUNCTION UTimer# (Timervar#)

     IF UTOrLoc$ <> "UT" THEN
         UTimer# = Timervar# + (UTDif% * 3600)
     ELSE
         UTimer# = Timervar#
     END IF
END FUNCTION

'*********************************************************************
'*   This standard subroutine simply pauses until a key is pressed.
'*   It also updates the time window.
'*
'*
'*********************************************************************
'
SUB WaitForKey (Key$)

     DO
          temp$ = INKEY$
          CALL SetTime
     LOOP UNTIL temp$ <> ""

     Key$ = temp$

END SUB '

'*********************************************************************
'*   This psychotic routine rewrites DPARMS.CFG while preserving all the
'*   user's comments.
'*
'*********************************************************************
'
SUB WriteCfg
              
     OPEN "dparms.cfg" FOR INPUT AS #5
     cntr = 1
     I% = 1
     DO
          cntr = 1
          LINE INPUT #5, temp$
          DO UNTIL LEFT$(temp$, 1) <> "*"
               CommentLine$(I%, cntr) = temp$
               IF EOF(5) = 0 THEN LINE INPUT #5, temp$ ELSE EXIT DO
               cntr = cntr + 1
          LOOP
          IF I% < 6 THEN I% = I% + 1
     LOOP UNTIL EOF(5)

     CLOSE #5


     OPEN "dparms.cfg" FOR OUTPUT AS #5
    
     cntr = 1
     DO UNTIL CommentLine$(1, cntr) = ""
          PRINT #5, CommentLine$(1, cntr)
          cntr = cntr + 1
     LOOP
     
     IF NiteMode$ = "Y" THEN
          NiteModeS$ = "NightMode"
     ELSE
          NiteModeS$ = "Standard"
     END IF
    
     PRINT #5, NiteModeS$
    
     cntr = 1
     DO UNTIL CommentLine$(2, cntr) = ""
          PRINT #5, CommentLine$(2, cntr)
          cntr = cntr + 1
     LOOP

     PRINT #5, STR$(UTDif%)

     cntr = 1
     DO UNTIL CommentLine$(3, cntr) = ""
          PRINT #5, CommentLine$(3, cntr)
          cntr = cntr + 1
     LOOP

     PRINT #5, UTOrLoc$

     cntr = 1
     DO UNTIL CommentLine$(4, cntr) = ""
          PRINT #5, CommentLine$(4, cntr)
          cntr = cntr + 1
     LOOP

     PRINT #5, STR$(BaseAddress%)

     cntr = 1
     DO UNTIL CommentLine$(5, cntr) = ""
          PRINT #5, CommentLine$(5, cntr)
          cntr = cntr + 1
     LOOP

     PRINT #5, STR$(SSPType%)

     cntr = 1
     DO UNTIL CommentLine$(6, cntr) = ""
          PRINT #5, CommentLine$(6, cntr)
          cntr = cntr + 1
     LOOP

     PRINT #5, STR$(NumPos%)

     cntr = 1
     DO UNTIL CommentLine$(7, cntr) = ""
          PRINT #5, CommentLine$(7, cntr)
          cntr = cntr + 1
     LOOP
    
     IF AorM$ = "Y" THEN
         AorM$ = "Auto"
     ELSE
         AorM$ = "Manual"
     END IF

     PRINT #5, AorM$
    
     cntr = 1
     DO UNTIL CommentLine$(8, cntr) = ""
         PRINT #5, CommentLine$(8, cntr)
         cntr = cntr + 1
     LOOP
     
     CLOSE #5
    
END SUB

'*********************************************************************
'*   This procedure writes a line to the Count Status window, doing
'*   that funky reverse-scrolling thing when necessary and keeping
'*   that top line constant.
'*
'*********************************************************************
'
SUB WriteCS (Text$)

'First let's make sure we have all the parameters we need.
     IF Status1.WheelA = 0 THEN EXIT SUB
             
'Grab the current filter name from the status window
     CurFilt$ = Status1.FiltName

'Add a decimal point to the integ time
     CurInteg$ = STR$(Status1.Integ / 1000)
     CurInteg$ = RIGHT$(CurInteg$, LEN(CurInteg$) - 1)
     IF LEFT$(CurInteg$, 1) = "." THEN CurInteg$ = "0" + CurInteg$
     IF INSTR(CurInteg$, ".") = 0 THEN CurInteg$ = CurInteg$ + ".0"

'Always keep that header there
     CALL LocRel(CountStatusWin, 1, 1)
     CALL WriteCharsHL(CountStatusWin, " DATE      TIME      CAT  OBJECT      FILTER        COUNT         INTEG  SCLE")
    
'Move everything down a line
     CSLines$(11) = CSLines$(10)
     CSLines$(10) = CSLines$(9)
     CSLines$(9) = CSLines$(8)
     CSLines$(8) = CSLines$(7)
     CSLines$(7) = CSLines$(6)
     CSLines$(6) = CSLines$(5)
     CSLines$(5) = CSLines$(4)
     CSLines$(4) = CSLines$(3)
     CSLines$(3) = CSLines$(2)
     CSLines$(2) = CSLines$(1)
    
'Set up the new line without overloading the string buffer
     CSLines$(1) = " " + LEFT$(CountStatus.IDate, 2) + "-" + MID$(CountStatus.IDate, 4, 2) + "-" + RIGHT$(CountStatus.IDate, 2)
     CSLines$(1) = CSLines$(1) + "  " + LEFT$(CountStatus.ITime, 8) + "  " + CurDL.Catalog + "    "
     CSLines$(1) = CSLines$(1) + CurDL.Object + "  " + CurFilt$ + " " + Text$ + "   " + RIGHT$("    " + CurInteg$, 6) + "  " + RIGHT$("  " + STR$(Status1.Gain), 3)
    
'Finally, we write the lines to the window
     FOR I = 1 TO 11
          CALL LocRel(CountStatusWin, 1, I + 1)
          CALL WriteCharsHL(CountStatusWin, CSLines$(I))
     NEXT I

END SUB   '

SUB WriteCSF (TheTime$, Num%, Text$)

'Always keep that header there
     CALL LocRel(CountStatusWin, 1, 1)
     CALL WriteCharsHL(CountStatusWin, " DATE      TIME           NUMBER     COUNT                                     ")
   
'Move everything down a line
     CSLines$(11) = CSLines$(10)
     CSLines$(10) = CSLines$(9)
     CSLines$(9) = CSLines$(8)
     CSLines$(8) = CSLines$(7)
     CSLines$(7) = CSLines$(6)
     CSLines$(6) = CSLines$(5)
     CSLines$(5) = CSLines$(4)
     CSLines$(4) = CSLines$(3)
     CSLines$(3) = CSLines$(2)
     CSLines$(2) = CSLines$(1)
   
'Set up the new line without overloading the string buffer
     CSLines$(1) = " " + LEFT$(DATE$, 2) + "-" + MID$(DATE$, 4, 2) + "-" + RIGHT$(DATE$, 2)
     CSLines$(1) = CSLines$(1) + "  " + TheTime$ + "  "
     CSLines$(1) = CSLines$(1) + LEFT$(STR$(Num%) + "       ", 7) + "   " + Text$ + "                                                  "
   
'Finally, we write the lines to the window
     FOR I = 1 TO 11
          CALL LocRel(CountStatusWin, 1, I + 1)
          CALL WriteCharsHL(CountStatusWin, CSLines$(I))
     NEXT I

END SUB

