'*********************************************************************
'*   This is the module with all the pulldown menu definitions and access
'*   code.
'*
'*********************************************************************
'
REM $INCLUDE: 'qb.bi'
COMMON SHARED NiteMode$
DECLARE FUNCTION NumPos% ()
DECLARE FUNCTION IntegTime% ()
DECLARE FUNCTION Fyle% ()
DECLARE FUNCTION FindFilter1% (FilterName$)
DECLARE FUNCTION Filter$ (Number AS INTEGER)
DECLARE FUNCTION OutPutMode ()
DECLARE SUB LoadFilters ()
DECLARE SUB CheckMenuActivate ()
DECLARE SUB LoadFilters ()
DECLARE SUB QBMouse (a, b, c, d)
DIM reg AS RegType

TYPE MenuReturn
	MenuSlct  AS INTEGER
	ItemSlct  AS INTEGER
END TYPE


	CONST Menus = 7
	CONST MaxItem = 16
    
	DIM SHARED HiPos1%(Menus), HiPos2%(Menus, MaxItem), MaxSize%(Menus), MaxItems%(Menus), Item$(Menus, MaxItem), valid%(Menus, MaxItem), toggle%(Menus, MaxItem)
	DIM SHARED CheckActive%(Menus, MaxItem)

	'Load in menu data from data statements at the end of this program
	    
	
	DIM SHARED menuline$, menurow%, menucol%, menuattr%, hotattr%, hiattr%, NVattr%
	DIM SHARED clearafter%, MenuSlct%, snd%, shadow%, ms%, seed%
	    
'---------------------------- End of Program Code ----------------------------

'=============================================================================
'                              M e n u   D a t a
'=============================================================================

'    The data statements are in the form
'    "MenuItemName", HotKey, Active, Toggle, MenuActivateType
'    The various codes for MenuActivateType are as follows
'
'    Type 1:   Always active - ex. Exit and Init Comm
'    Type 2:   Active with valid comm connection and no prompt - ex. filters
'    Type 3:   Active with comm and output file - ex. run olist and fastmode
'    Type 4:   Active when running olist or fastmode - ex. Halt


PullDownMenuData:

	'File Menu

	DATA 5, 12
	DATA "Open", 1,1,0,1
	DATA "Close",1,0,0,2
	DATA "OList",2,1,0,2
	DATA "~",0,0,0,5
	DATA "Exit",2,1,0,1

	'Object menu

	DATA 7,13
	DATA "Object Name",1,0,0,1
	DATA "Catalog",1,0,0,1
	DATA "Filter",1,0,0,1
	DATA "~",0,0,0,5
	DATA "SkyNext",4,0,0,1
	DATA "Sky",1,0,0,1
	DATA "SkyLast",4,0,0,1
    

	'Run Menu

	DATA 9,18
	DATA "Read Trial",0,0,0,1
	DATA "~",0,0,0,5
	DATA "Run OList",5,0,0,3
	DATA "Run SlowMode",1,0,0,1
	DATA "Test FastMode",6,0,0,1
	DATA "Run FastMode-A",14,0,0,1
	DATA "Run FastMode-B",14,0,0,1
	DATA "Toggle AutoObject",13,0,0,1
	DATA "Toggle AutoSky",13,0,0,1

	'Parms Menu

	DATA 5, 18
	DATA "Home Filters", 1,0,0,1
	DATA "Set Interval",1,0,0,1
	DATA "Set FInterval",1,0,0,1
	DATA "Set Integ",5,0,0,1
	DATA "Set Scale",5,0,0,1

	'Filter Menu

	DATA 10,3
	DATA " 1 ",1,0,0,1
	DATA " 2 ",1,0,0,1
	DATA " 3 ",1,0,0,1
	DATA " 4 ",1,0,0,1
	DATA " 5 ",1,0,0,1
	DATA " 6 ",1,0,0,1
	DATA " 7 ",1,0,0,1
	DATA " 8 ",1,0,0,1
	DATA " 9 ",1,0,0,1
	DATA "10 ",1,0,0,1

	'setup menu

	DATA 3, 23
	DATA "Toggle Night Mode",1,1,0,1
	DATA "Catalog Error Checking",9,0,1,1
	DATA "Set Time Options",1,1,0,1
   
	'Development Menu - not for use with release versions
    
'     DATA 2,24
'     DATA "Show Memory",1,1,0,1
'     DATA "Temp. Function Test",1,1,0,1

	'Help Menu

	DATA 2, 12
	DATA "Help (F1)",1,1,0,1
	DATA "About...",1,1,0,1
	
'

'*********************************************************************
'*   This function uses the activate codes as defined in the main
'*   module level code to determine which selections should be active.
'*   If things get much more complex, some rethinking of this code will
'*   be needed.
'*********************************************************************
'
SUB CheckMenuActivate

	DIM Level AS INTEGER

' First determine the level
	IF OutPutMode > 0 THEN
		IF OutPutMode > 1 THEN
			Level = 3
		ELSE
			Level = 2
		END IF
	ELSE
		Level = 1
	END IF

' And then use it
	FOR I% = 1 TO 7
		FOR J% = 1 TO MaxItems%(I%)
			IF CheckActive%(I%, J%) <= Level THEN
				valid%(I%, J%) = 1
			ELSE
				valid%(I%, J%) = 0
			END IF
		NEXT J%
	NEXT I%

    
 'This dims out the last four filter positions if the user is using a 6-position
 'filter slider

 IF NumPos% = 6 THEN
	FOR I% = 7 TO 10
		valid%(5, I%) = 0
	NEXT I%
 END IF



 'This next part is for the special cases of the Read items;
 'FastMode and SlowMode
    
	SELECT CASE Fyle%
		CASE 0
			IF RIGHT$(STR$(IntegTime%), 3) = "000" THEN
				valid%(3, 4) = 1
			ELSE
				valid%(3, 3) = 0
				valid%(3, 4) = 0
			END IF
			valid%(3, 5) = 1
			valid%(3, 6) = 1
			valid%(3, 7) = 1
		CASE 1
			valid%(3, 3) = 0
			valid%(3, 4) = 0
			valid%(3, 5) = 1
			valid%(3, 6) = 1
			valid%(3, 7) = 1
		CASE 2
			IF RIGHT$(STR$(IntegTime%), 3) = "000" THEN
				valid%(3, 4) = 1
			ELSE
				valid%(3, 3) = 0
				valid%(3, 4) = 0
			END IF
			valid%(3, 5) = 1
			valid%(3, 6) = 0
			valid%(3, 7) = 0
	END SELECT

END SUB '

'*********************************************************************
'*   This is where the pulldown routine is actually called, after
'*   CheckMenuActivate determines what should be selectable.
'*
'*
'*********************************************************************
'
SUB DoPullDown (Menu%, Item%)

	CALL CheckMenuActivate
    
	DEF SEG = 0
	POKE (1050), PEEK(1052)  'empty keyboard buffer
	DEF SEG
	CALL PULLDOWN(menuline$, menurow%, menucol%, menuattr%, hotattr%, hiattr%, NVattr%, HiPos1%(), HiPos2%(), MaxSize%(), MaxItems%(), Item$(), valid%(), toggle%(), ms%, clearafter%, MenuSlct%, shadow%, snd%, MenuSlct%, ItemSlct%)
	seed% = MenuSlct%
	IF seed% = 0 THEN seed% = 1
	QBMouse 2, b, c, d
	COLOR 0, 7
	IF NiteMode$ = "Y" THEN COLOR 0, 4
	LOCATE 1, 1
	PRINT menuline$;
	QBMouse 1, b, c, d

	Menu% = MenuSlct%
	Item% = ItemSlct%

END SUB '

'*********************************************************************
'*   This returns the name of the Number filter of Wheel from the filter
'*   config file, filtering out any non-alphabetical characters.
'*
'*
'*********************************************************************
'
FUNCTION Filter$ (Number AS INTEGER)

	Name$ = ""

	temp$ = Item$(5, Number)
    
	FOR I% = 1 TO LEN(temp$)
		temp2$ = MID$(temp$, I%, 1)
		IF 64 < ASC(temp2$) AND ASC(temp2$) < 91 THEN Name$ = Name$ + temp2$
		IF 96 < ASC(temp2$) AND ASC(temp2$) < 123 THEN Name$ = Name$ + temp2$
	NEXT I%

	Filter$ = Name$

END FUNCTION '

'*********************************************************************
'*   This function is basically the inverse of the Filter$ function.
'*   Given a two-letter filtername, it finds the first filter
'*   that has a first letter matching the FilterName$.  This
'*   is used to find the correct filter for an OList.
'*********************************************************************
'
FUNCTION FindFilter1% (FilterName$)

	FOR I% = 1 TO 6
		IF INSTR(Item$(5, I%), FilterName$) <> 0 THEN
			FindFilter1% = I%
			EXIT FUNCTION
		END IF
	NEXT I%

END FUNCTION '

'*********************************************************************
'*   This is the routine that initialy reads in the pulldown menu
'*   descriptions and calls the routine that loads in the filter names
'*   from the disk config file.  If any changes are made to the menus,
'*   chances are changes will also be needed here.
'*********************************************************************
'
SUB InitPullDown

	CLS
	RESTORE PullDownMenuData
   
	menuline$ = "   File  Object  Run  Parms  Filter  Setup                      Help            "
    
	FOR Menu% = 1 TO 7
		READ MaxItems%(Menu%)               'Number of selections in each menu
		READ MaxSize%(Menu%)                'Max length of items in each menu
		FOR Slct% = 1 TO MaxItems%(Menu%)
			READ Item$(Menu%, Slct%)       'Text displayed for selection
			READ HiPos2%(Menu%, Slct%)      'Hot key for each selection in menu
			READ valid%(Menu%, Slct%)       'Determines if grayed out or not
			READ toggle%(Menu%, Slct%)      'Determines if selection can be
			READ CheckActive%(Menu%, Slct%) 'Determines when the menu should be active
		NEXT Slct%
	NEXT Menu%

	IF FiltsLoaded% = 0 THEN
		CALL LoadFilters
		FiltsLoaded% = 1
	END IF

	menurow% = 1                             'Screen row of menu line
	menucol% = 1                             'Beginning column position
	menuattr% = 7 * 16 + 0                   'Menu color
	IF NiteMode$ = "Y" THEN menuattr% = 4
	hotattr% = 7 * 16 + 15                   'Hot key hilite color
	IF NiteMode$ = "Y" THEN hotattr% = 12
	hiattr% = 0 * 16 + 7                     'Hilite bar color
		IF NiteMode$ = "Y" THEN hiattr% = 64
	NVattr% = 7 * 16 + 8                     'color for grayed-out
	IF NiteMode$ = "Y" THEN NVattr% = 0        '   selections
	clearafter% = 1                          'erase menu after selection
	MenuSlct% = 1                            'menu to start with
	snd% = 1                                 'turn sound on
	IF NiteMode$ <> "Y" THEN shadow% = 4 ELSE shadow% = 0

	FOR I% = 1 TO 7           'HiPos1() holds the location in each menu
		HiPos1%(I%) = 1       'name for the 'hot' key - in this case it
	NEXT I%                   'is the first letter in each name.

	HiPos1%(5) = 5

	COLOR 0, 7
	IF NiteMode$ = "Y" THEN COLOR 0, 4
	LOCATE 1, 1
	PRINT menuline$;

	ms% = 1                            'use a mouse
	CALL QBMouse(0, 0, 0, 0)           'init mouse


END SUB '

'*********************************************************************
'*   This is where the names and hotkeys for the filters are read from
'*   a disk file.  The format is FILTNAME, HOTKEYPOS.  The first 8 readable
'*   lines are the filter names.  Lines beginning with an asterisk are
'*   ignored.
'*********************************************************************
'
SUB LoadFilters

	OPEN "FILTERS.CFG" FOR INPUT AS #4

	cntr = 1

	DO UNTIL cntr = 11
		INPUT #4, Item$(5, cntr)
		IF LEFT$(Item$(5, cntr), 1) <> "*" THEN
			IF LEN(Item$(5, cntr)) + 2 > MaxSize%(5) THEN
				MaxSize%(5) = LEN(Item$(5, cntr)) + 2
			END IF
			INPUT #4, HiPos2%(5, cntr)
			cntr = cntr + 1
		END IF
	LOOP

	CLOSE #4

END SUB '

'*********************************************************************
'*  This is simply the mouse routine copied directly from the PDDEMO
'*  files.
'*
'*
'*********************************************************************
'
SUB QBMouse (a, b, c, d)

	SHARED reg AS RegType
	reg.ax = a
	reg.bx = b
	reg.cx = c
	reg.dx = d
	CALL INTERRUPT(&H33, reg, reg)
	a = reg.ax
	b = reg.bx
	c = reg.cx
	d = reg.dx

END SUB

